--
--	Copyright Cypress Semiconductor Corporation, 1994,1995,1996
--	  as an unpublished work.
--

PACKAGE mathpkg IS
    COMPONENT add
	PORT (CI,
	    A, B: IN BIT;
            SUM, CO: OUT BIT);
    END COMPONENT;

    COMPONENT sub
	PORT (CI,
	    A, B: IN BIT;
            DIF, CO: OUT BIT);
    END COMPONENT;

    COMPONENT add4
	PORT (CI : IN BIT;
	    A3,A2,A1,A0: IN BIT;
	    B3,B2,B1,B0: IN BIT;
	    SUM3,SUM2,SUM1,SUM0 : OUT BIT;
            CO: OUT BIT);
    END COMPONENT;

    COMPONENT fcadd4
	PORT (CI : IN BIT;
	    A3,A2,A1,A0: IN BIT;
	    B3,B2,B1,B0: IN BIT;
	    SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT fbsub4
	PORT (CI : IN BIT;
	    A3,A2,A1,A0: IN BIT;
	    B3,B2,B1,B0: IN BIT;
	    DIF3,DIF2,DIF1,DIF0 : OUT BIT;
            CO: OUT BIT);
    END COMPONENT;

    COMPONENT add8
	PORT (CI : IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT fcadd8
	PORT (CI : IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT nciadd8
	PORT (
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT fbsub8
	PORT (CI : IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    DIF7,DIF6,DIF5,DIF4,DIF3,DIF2,DIF1,DIF0 : OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT add16
	PORT (CI : IN BIT;
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8 : OUT BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT fcadd16
	PORT (CI : IN BIT;
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8 : OUT BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT nciadd16
	PORT (
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8 : OUT BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT fbsub16
	PORT (CI : IN BIT;
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    DIF15,DIF14,DIF13,DIF12,DIF11,DIF10,DIF9,DIF8 : OUT BIT;
	    DIF7,DIF6,DIF5,DIF4,DIF3,DIF2,DIF1,DIF0 : OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT mult4x4
        PORT (b3,b2,b1,b0,m3,m2,m1,m0 : IN BIT;
              q7,q6,q5,q4,q3,q2,q1,q0 : OUT BIT);
    END COMPONENT;

    COMPONENT COMPBIT2
	PORT (
	    A0,B0,A1,B1 : IN BIT;
	    EQ0, EQ1	: OUT BIT);
    END COMPONENT;

    COMPONENT EQCOMP4
	PORT (
	    A3,A2,A1,A0,B3,B2,B1,B0 : IN BIT;
	    EQ	: OUT	BIT);
    END COMPONENT;

    COMPONENT EQCOMP8
	PORT (
	    A7,A6,A5,A4,A3,A2,A1,A0,B7,B6,B5,B4,B3,B2,B1,B0 : IN BIT;
	    EQ	: OUT	BIT);
    END COMPONENT;

    COMPONENT EQCOMP16
	PORT (
	    A15,A14,A13,A12,A11,A10,A9,A8,A7,A6,A5,A4,A3,A2,A1,A0 : IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0 : IN BIT;
	    EQ	: OUT	BIT);
    END COMPONENT;

END mathpkg;

--
--	ADD
--

USE WORK.cypress.ALL;

ENTITY add IS
	PORT (CI: IN BIT;
	      A, B: IN BIT;
	      SUM: OUT BIT;
	      CO: OUT BIT);
END add;

ARCHITECTURE archadd OF add IS

BEGIN
	SUM <= (A XOR B) XOR CI;
	CO <= (A AND B) OR ((A AND CI) OR (B AND CI));

END archadd;

--
--	SUBtract
--

USE WORK.cypress.ALL;

ENTITY sub IS
	PORT (CI: IN BIT;
	      A, B: IN BIT;
	      DIF: OUT BIT;
	      CO: OUT BIT);
END sub;

ARCHITECTURE archsub OF sub IS

BEGIN
	DIF <= NOT(NOT(A XOR B) XOR CI);
	CO <= (not A AND B) OR ((not A AND CI) OR (B AND CI));

END archsub;

--
--	ADD 4
--

USE WORK.MATHPKG.ALL;
ENTITY add4 IS
	PORT (CI : IN BIT;
	    A3,A2,A1,A0: IN BIT;
	    B3,B2,B1,B0: IN BIT;
	    SUM3,SUM2,SUM1,SUM0 : OUT BIT;
            CO: OUT BIT);
END add4;

ARCHITECTURE archADD4 of ADD4 IS

BEGIN
	U0:fcadd4 port map (ci,a3,a2,a1,a0,b3,b2,b1,b0,sum3,sum2,sum1,sum0,co);

END archADD4;

--
--	Fast Carry ADD 4
--

ENTITY fcadd4 IS
	PORT (CI : IN BIT;
	    A3,A2,A1,A0: IN BIT;
	    B3,B2,B1,B0: IN BIT;
	    SUM3,SUM2,SUM1,SUM0 : OUT BIT;
            CO: OUT BIT);
END fcadd4;

ARCHITECTURE archfcadd4 OF fcadd4 IS

	signal no1_o,no2_o,no3_o,no4_o: bit;
	signal na1_o,na2_o,na3_o,na4_o: bit;

BEGIN

	no1_o <= not(a0  or b0);
	na1_o <= not(a0 and b0);
	no2_o <= not(a1  or b1);
	na2_o <= not(a1 and b1);
	no3_o <= not(a2  or b2);
	na3_o <= not(a2 and b2);
	no4_o <= not(a3  or b3);
	na4_o <= not(a3 and b3);

	co <= not( (no4_o) or 
	 	   (na4_o and no3_o) or
		   (no2_o and na4_o and na3_o) or
		   (no1_o and na4_o and na3_o and na2_o) or
		   ((not ci) and na4_o and na3_o and na2_o and na1_o)
		) ;

	sum3 <=  (na4_o and (not no4_o)) xor
		   not ((no3_o) or
                        (no2_o and na3_o) or
			(no1_o and na3_o and na2_o) or
			(na3_o and na2_o and na1_o and (not ci))
		       );

	sum2 <= (na3_o and (not no3_o)) xor
		  not ((no2_o) or
			(no1_o and na2_o) or
			(na2_o and na1_o and (not ci))
		      );

	sum1 <= (na2_o and (not no2_o)) xor
		  not ((no1_o) or
			(na1_o and (not ci))
			);
	
	sum0 <= (na1_o and (not no1_o)) xor ci;

END archfcadd4;

--
--	Fast Borrow SUBtract 4
--

ENTITY fbsub4 IS
	PORT (CI : IN BIT;
	    A3,A2,A1,A0: IN BIT;
	    B3,B2,B1,B0: IN BIT;
	    DIF3,DIF2,DIF1,DIF0 : OUT BIT;
            CO: OUT BIT);
END fbsub4;


ARCHITECTURE archfbsub4 OF fbsub4 IS

	signal no1_o,no2_o,no3_o,no4_o : bit;
	signal na1_o,na2_o,na3_o,na4_o : bit; 

BEGIN

	no1_o <= not(not a0  or b0);
	na1_o <= not(not a0 and b0);
	no2_o <= not(not a1  or b1);
	na2_o <= not(not a1 and b1);
	no3_o <= not(not a2  or b2);
	na3_o <= not(not a2 and b2);
	no4_o <= not(not a3  or b3);
	na4_o <= not(not a3 and b3);

	co <= not( (no4_o) or 
	 	   (na4_o and no3_o) or
		   (no2_o and na4_o and na3_o) or
		   (no1_o and na4_o and na3_o and na2_o) or
		   ((not ci) and na4_o and na3_o and na2_o and na1_o)
		) ;

	dif3 <=  not((na4_o and (not no4_o)) xor
		   not ((no3_o) or
                        (no2_o and na3_o) or
			(no1_o and na3_o and na2_o) or
			(na3_o and na2_o and na1_o and (not ci))
			));

	dif2 <= not((na3_o and (not no3_o)) xor
		  not ((no2_o) or
			(no1_o and na2_o) or
			(na2_o and na1_o and (not ci))
			));

	dif1 <= not((na2_o and (not no2_o)) xor
		  not ((no1_o) or
			(na1_o and (not ci))
			));
	
	dif0 <= not((na1_o and (not no1_o)) xor ci);

END archfbsub4;

--
--	ADD 8
--

use work.mathpkg.all;
ENTITY add8 is
	PORT (CI : IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
end add8;

architecture archADD8 of ADD8 is
BEGIN
 
	 U0:fcadd8 port map (ci,a7,a6,a5,a4,a3,a2,a1,a0,
				b7,b6,b5,b4,b3,b2,b1,b0,
				sum7,sum6,sum5,sum4,sum3,sum2,sum1,sum0,co);

END archADD8;

--
--	Fast Carry ADD 8
--

ENTITY fcadd8 is
	PORT (CI : IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
end fcadd8;

architecture archFCADD8 of FCADD8 is

	signal cx: bit;

begin
	a0: fcadd4 port map (ci,a3,a2,a1,a0,b3,b2,b1,b0,sum3,sum2,sum1,sum0,cx);
	a1: fcadd4 port map (cx,a7,a6,a5,a4,b7,b6,b5,b4,sum7,sum6,sum5,sum4,co);

end archFCADD8;

--
--	No Carry In ADD 8
--

ENTITY nciadd8 is
	PORT (
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
end nciadd8;

architecture archNCIADD8 of NCIADD8 is

begin

    U0: fcadd8 port map(zero,
			a7,a6,a5,a4,a3,a2,a1,a0,b7,b6,b5,b4,b3,b2,b1,b0,
			sum7,sum6,sum5,sum4,sum3,sum2,sum1,sum0,co);

end archNCIADD8;

--
--	Fast Borrow SUBtract 8
--

ENTITY fbsub8 is
	PORT (CI : IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    DIF7,DIF6,DIF5,DIF4,DIF3,DIF2,DIF1,DIF0 : OUT BIT;
	    CO: OUT BIT);
end fbsub8;

architecture archfbsub8 of fbsub8 is

	signal cx: bit;

begin
	a0: fbsub4 port map (ci,a3,a2,a1,a0,b3,b2,b1,b0,dif3,dif2,dif1,dif0,cx);
	a1: fbsub4 port map (cx,a7,a6,a5,a4,b7,b6,b5,b4,dif7,dif6,dif5,dif4,co);

end archfbsub8;

--
--	ADD 16
--

use work.mathpkg.all;
ENTITY add16 is
	PORT (CI : IN BIT;
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8 : OUT BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
end add16;

architecture archADD16 of ADD16 is
BEGIN
 
    U0:fcadd16 port map(ci,
	a15,a14,a13,a12,a11,a10,a9,a8,a7,a6,a5,a4,a3,a2,a1,a0,
	b15,b14,b13,b12,b11,b10,b9,b8,b7,b6,b5,b4,b3,b2,b1,b0,
	sum15,sum14,sum13,sum12,sum11,sum10,sum9,sum8,
	sum7,sum6,sum5,sum4,sum3,sum2,sum1,sum0,co);

END archADD16;

--
--	Fast Carry ADD 16
--

ENTITY fcadd16 is
	PORT (CI : IN BIT;
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8 : OUT BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
end fcadd16;

architecture archFCADD16 of FCADD16 is

	signal c1,c2,c3: bit;

begin
	a0: fcadd4 port map (ci,a3,a2,a1,a0,b3,b2,b1,b0,sum3,sum2,sum1,sum0,c1);
	a1: fcadd4 port map (c1,a7,a6,a5,a4,b7,b6,b5,b4,sum7,sum6,sum5,sum4,c2);
	a2: fcadd4 port map
	    (c2,a11,a10,a9,a8,b11,b10,b9,b8,sum11,sum10,sum9,sum8,c3);
	a3: fcadd4 port map
	    (c3,a15,a14,a13,a12,b15,b14,b13,b12,sum15,sum14,sum13,sum12,co);

end archFCADD16;

--
--	No Carry In ADD 16
--

ENTITY nciadd16 is
	PORT (
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8 : OUT BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
end nciadd16;

architecture archNCIADD16 of NCIADD16 is

begin

    U0: fcadd16 port map(zero,
			a15,a14,a13,a12,a11,a10,a9,a8,a7,a6,a5,a4,a3,a2,a1,a0,
			b15,b14,b13,b12,b11,b10,b9,b8,b7,b6,b5,b4,b3,b2,b1,b0,
			sum15,sum14,sum13,sum12,sum11,sum10,sum9,sum8,
			sum7, sum6, sum5, sum4, sum3, sum2, sum1,sum0,co);

end archNCIADD16;

--
--	Fast Borrow SUBtract 16
--

ENTITY fbsub16 is
	PORT (CI : IN BIT;
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    DIF15,DIF14,DIF13,DIF12,DIF11,DIF10,DIF9,DIF8 : OUT BIT;
	    DIF7,DIF6,DIF5,DIF4,DIF3,DIF2,DIF1,DIF0 : OUT BIT;
	    CO: OUT BIT);
end fbsub16;

architecture archfbsub16 of fbsub16 is

	signal c1,c2,c3: bit;

begin
	a0: fbsub4 port map (ci,a3,a2,a1,a0,b3,b2,b1,b0,dif3,dif2,dif1,dif0,c1);
	a1: fbsub4 port map (c1,a7,a6,a5,a4,b7,b6,b5,b4,dif7,dif6,dif5,dif4,c2);
	a2: fbsub4 port map
	    (c2,a11,a10,a9,a8,b11,b10,b9,b8,dif11,dif10,dif9,dif8,c3);
	a3: fbsub4 port map
	    (c3,a15,a14,a13,a12,b15,b14,b13,b12,dif15,dif14,dif13,dif12,co);

end archfbsub16;

--
--	MULTiply 4 X 4
--

ENTITY mult4x4 IS
        PORT (b3,b2,b1,b0,m3,m2,m1,m0 : IN BIT;
              q7,q6,q5,q4,q3,q2,q1,q0 : OUT BIT);
END mult4x4;

ARCHITECTURE archMULT4x4 of mult4x4 IS

	signal D0,D1,D2,D3,E0,E1,E2,E3,F0,F1,F2,F3,G0,G1,G2,G3     	: bit;
	signal c_12,c_13,c_14,c_15,c_23,c_24,c_25,c_26,c_34,c_35,c_36   : bit;
	signal s_13,s_14,s_15,s_24,s_25,s_26     	           	: bit;
BEGIN

	D0 <= (m0 and b0);
        D1 <= (m0 and b1);
        D2 <= (m0 and b2);
        D3 <= (m0 and b3);
        E0 <= (m1 and b0);
        E1 <= (m1 and b1);
        E2 <= (m1 and b2);
        E3 <= (m1 and b3);
        F0 <= (m2 and b0);
        F1 <= (m2 and b1);
        F2 <= (m2 and b2);
        F3 <= (m2 and b3);
        G0 <= (m3 and b0);
        G1 <= (m3 and b1);
        G2 <= (m3 and b2);
        G3 <= (m3 and b3);
        c_12 <= (D1 and E0);
        c_13 <= ((D2 and E1) or (D2 and c_12) or (E1 and c_12));
        c_14 <= ((D3 and E2) or (D3 and c_13) or (E2 and c_13));
        c_15 <= (E3 and c_14);
        s_13 <= (D2 xor E1 xor c_12);
        s_14 <= (D3 xor E2 xor c_13);
        s_15 <= (E3 xor c_14);
        c_23 <= (F0 and s_13);
        c_24 <= ((s_14 and F1) or (s_14 and c_23) or (F1 and c_23));
        c_25 <= ((s_15 and F2) or (s_15 and c_24) or (F2 and c_24));
        c_26 <= ((c_15 and F3) or (c_15 and c_25) or (F3 and c_25));
        s_24 <= (c_23 xor s_14 xor F1);
        s_25 <= (c_24 xor s_15 xor F2);
        s_26 <= (c_25 xor c_15 xor F3);
        c_34 <= (G0 and s_24);
        c_35 <= ((s_25 and G1) or (s_25 and c_34) or (G1 and c_34));
        c_36 <= ((s_26 and G2) or (s_26 and c_35) or (G2 and c_35));
 
        q0 <= D0;
        q1 <= (D1 xor E0);
        q2 <= (s_13 xor F0);
        q3 <= (s_24 xor G0);
        q4 <= (c_34 xor s_25 xor G1);
        q5 <= (c_35 xor s_26 xor G2);
        q6 <= (c_36 xor c_26 xor G3);
        q7 <= ((c_26 and G3) or (c_26 and c_36) or (G3 and c_36));
 
END archMULT4x4;

--
--	COMPare 2 BITs
--

use work.cypress.all;

entity COMPBIT2 is
    PORT (
	A0,B0,A1,B1 : IN BIT;
	EQ0, EQ1 : OUT BIT);
end COMPBIT2;

architecture archCOMPBIT2 of COMPBIT2 is
begin

	eq0 <= (NOT(a1 xor b1) AND a0 AND NOT b0) OR (NOT a0 AND b0);
	eq1 <= (NOT(a1 xor b1));

end archCOMPBIT2;

--
--	EQual COMPare 4
--

use work.cypress.all;

entity EQCOMP4 is
	PORT (
	    A3,A2,A1,A0,B3,B2,B1,B0 : IN BIT;
	    EQ	: OUT	BIT);
end EQCOMP4;

architecture archEQCOMP4 of EQCOMP4 is

	signal			   e3,e2,e1,e0:	bit;

begin
	e3 <= a3 xor b3;
	e2 <= a2 xor b2;
	e1 <= a1 xor b1;
	e0 <= a0 xor b0;

	eq <= (not e3 and not e2 and not e1 and not e0);

end archEQCOMP4;

--
--	EQual COMPare 8
--

use work.cypress.all;

entity EQCOMP8 is
	PORT (
	    A7,A6,A5,A4,A3,A2,A1,A0,B7,B6,B5,B4,B3,B2,B1,B0 : IN BIT;
	    EQ	: OUT	BIT);
end EQCOMP8;

architecture archEQCOMP8 of EQCOMP8 is

	signal e7,e6,e5,e4,e3,e2,e1,e0: bit;

begin
	e7 <= a7 xor b7;
	e6 <= a6 xor b6;
	e5 <= a5 xor b5;
	e4 <= a4 xor b4;
	e3 <= a3 xor b3;
	e2 <= a2 xor b2;
	e1 <= a1 xor b1;
	e0 <= a0 xor b0;

	eq <= not e7 and not e6 and not e5 and not e4
	  and not e3 and not e2 and not e1 and not e0;

end archEQCOMP8;

--
--	EQual COMPare 16
--

use work.cypress.all;

entity EQCOMP16 is
	PORT (
	    A15,A14,A13,A12,A11,A10,A9,A8,A7,A6,A5,A4,A3,A2,A1,A0 : IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0 : IN BIT;
	    EQ	: OUT	BIT);
end EQCOMP16;

architecture archEQCOMP16 of EQCOMP16 is

	signal e1,e0 : bit;

begin
	C1: eqcomp8 port map (a15,a14,a13,a12,a11,a10,a9,a8,
				b15,b14,b13,b12,b11,b10,b9,b8,e1);
	C0: eqcomp8 port map (a7,a6,a5,a4,a3,a2,a1,a0,
				b7,b6,b5,b4,b3,b2,b1,b0,e0);
	eq <= e1 AND e0 ;

end archEQCOMP16;
