--
--      Copyright Cypress Semiconductor Corporation, 1995,1996
--	as an unpublished work.
--

package ttl_local is

component bufoe
    port(
	x	: in bit;		-- Logic input to Buffer.
	oe	: in bit;		-- Output Enable input.
	y	: inout x01z;		-- Output pin.
	yfb	: out bit		-- Output feed back as bit.
    );
end component;
component triout
    port(
	x	: in bit;		-- Logic input to Buffer.
	oe	: in bit;		-- Output Enable input.
	y	: out x01z		-- Output pin.
    );
end component;
component dsrff
    port(
	d	: in bit;		-- D input to register.
	s	: in bit;		-- Set input Async.
	r	: in bit;		-- Reset input Async.
	clk	: in bit;		-- Positive edge Clock.
	q	: out bit		-- Output from register.
    );
end component;
component dff
    port(
	d	: in bit;		-- D input to register.
	clk	: in bit;		-- Positive edge Clock.
	q	: out bit		-- Output from register.
    );
end component;
component dltch
    port(
	d	: in bit;		-- D input to latch.
	e	: in bit;		-- Enabel, tranparent high.
	q	: out bit		-- Qutput from latch.
    );
end component;
component dsrlch 
    port (
	d	: in bit;
	s	: in bit;
	r	: in bit;
	e	: in bit;
	q	: out bit
    );
end component;

	COMPONENT De2X4
	PORT(
		EN: IN BIT;
		S0: IN BIT;
		S1: IN BIT;
		Y0: OUT BIT;
		Y1: OUT BIT;
		Y2: OUT BIT;
		Y3: OUT BIT);
	END COMPONENT;

	COMPONENT De3X8
	PORT(
		EN: IN BIT;
		S0: IN BIT;
		S1: IN BIT;
		S2: IN BIT;
		Y0: OUT BIT;
		Y1: OUT BIT;
		Y2: OUT BIT;
		Y3: OUT BIT;
		Y4: OUT BIT;
		Y5: OUT BIT;
		Y6: OUT BIT;
		Y7: OUT BIT);
	END COMPONENT;

	COMPONENT De4X16
	PORT(
		EN: IN BIT;
		S0: IN BIT;
		S1: IN BIT;
		S2: IN BIT;
		S3: IN BIT;
		Y0: OUT BIT;
		Y1: OUT BIT;
		Y2: OUT BIT;
		Y3: OUT BIT;
		Y4: OUT BIT;
		Y5: OUT BIT;
		Y6: OUT BIT;
		Y7: OUT BIT;
		Y8: OUT BIT;
		Y9: OUT BIT;
		Y10: OUT BIT;
		Y11: OUT BIT;
		Y12: OUT BIT;
		Y13: OUT BIT;
		Y14: OUT BIT;
		Y15: OUT BIT);
	END COMPONENT;

	COMPONENT Mux1of2
	PORT(
		EN: IN BIT;
		S:  IN BIT;
		D0: IN BIT;
		D1: IN BIT;
		Y:  OUT BIT);
	END COMPONENT;

	COMPONENT Mux1of4
	PORT(
		EN: IN BIT;
		S0: IN BIT;
		S1: IN BIT;
		D0: IN BIT;
		D1: IN BIT;
		D2: IN BIT;
		D3: IN BIT;
		Y:  OUT BIT);
	END COMPONENT;

	COMPONENT Mux1of8
	PORT(
		EN: IN BIT;
		S0: IN BIT;
		S1: IN BIT;
		S2: IN BIT;
		D0: IN BIT;
		D1: IN BIT;
		D2: IN BIT;
		D3: IN BIT;
		D4: IN BIT;
		D5: IN BIT;
		D6: IN BIT;
		D7: IN BIT;
		Y: OUT BIT);
	END COMPONENT;

	COMPONENT Mux1of16
	PORT(
		EN: IN BIT;
		S0: IN BIT;
		S1: IN BIT;
		S2: IN BIT;
		S3: IN BIT;
		D0: IN BIT;
		D1: IN BIT;
		D2: IN BIT;
		D3: IN BIT;
		D4: IN BIT;
		D5: IN BIT;
		D6: IN BIT;
		D7: IN BIT;
		D8: IN BIT;
		D9: IN BIT;
		D10: IN BIT;
		D11: IN BIT;
		D12: IN BIT;
		D13: IN BIT;
		D14: IN BIT;
		D15: IN BIT;
		Y: OUT BIT);
	END COMPONENT;

    COMPONENT shift8
	PORT (SI	: IN BIT;
	    L	: IN BIT;
	    D7,D6,D5,D4,D3,D2,D1,D0 	: IN BIT;
	    EN	: IN BIT;
	    CLK	: IN BIT;
	    R	: IN BIT;
	    Q7,Q6,Q5,Q4,Q3,Q2,Q1,Q0 	: OUT BIT);
    END COMPONENT;

    COMPONENT unsr8
	PORT (SL	: IN BIT;
	    SR	: IN BIT;
	    S0	: IN BIT;
	    S1	: IN BIT;
	    D7,D6,D5,D4,D3,D2,D1,D0 	: IN BIT;
	    CLK	: IN BIT;
	    R	: IN BIT;
	    Q7,Q6,Q5,Q4,Q3,Q2,Q1,Q0 	: OUT BIT);
    END COMPONENT;

	COMPONENT jksrff 
	PORT (J : IN BIT;
	      K : IN BIT;
	      S : IN BIT;
	      R : IN BIT;
	      CLK : IN BIT;
	      Q : OUT BIT);
        END COMPONENT;

    COMPONENT cntr4
	PORT (  CI: IN BIT;
		CO: OUT BIT;
	        EN: IN BIT;
 		L: IN BIT;
	        D3,D2,D1,D0: IN BIT;
		CLK: IN BIT;
	        R: IN BIT;
		Q3,Q2,Q1,Q0: OUT BIT);
    END COMPONENT;

    COMPONENT updn4
	PORT (	CI: IN BIT;	-- cascade in
		CO: OUT BIT;	-- cascade out
		UP: IN BIT;	-- up, not down
		EN: IN BIT;	-- enable
		L: IN BIT;	-- load 
	        D3,D2,D1,D0: IN BIT;
		CLK: IN BIT;	-- clock
		R: IN BIT;	-- reset
		Q3,Q2,Q1,Q0: OUT BIT);

    END COMPONENT;

	COMPONENT reg4
	PORT(D3, D2, D1, D0: IN BIT;
	     EN: IN BIT;
	     CLK: IN BIT;
	     R: IN BIT;
	     Q3, Q2, Q1, Q0: OUT BIT);
	END COMPONENT;
end ttl_local ;
 
--
--	TTL00
--

use work.ttl_local.all;

entity TTL00 is
    port(QN: OUT bit;
         A: IN bit;
         B: IN bit);
end TTL00;

architecture archTTL00 of TTL00 is

begin
    QN <= NOT (A AND B) ;

end archTTL00;

--
--	TTL02
--

use work.ttl_local.all;

entity TTL02 is
    port(QN: OUT bit;
         A: IN bit;
         B: IN bit);
end TTL02;

architecture archTTL02 of TTL02 is

begin
    QN <=  NOT (A OR B) ;

end archTTL02;

--
--	TTL04
--

use work.ttl_local.all;

entity TTL04 is
    port(QN: OUT bit;
         A: IN bit);
end TTL04;

architecture archTTL04 of TTL04 is

begin
    QN <= NOT A ;

end archTTL04;

--
--	TTL08
--

use work.ttl_local.all;

entity TTL08 is
    port(Q: OUT bit;
         A: IN bit;
	 B: IN bit);
end TTL08;

architecture archTTL08 of TTL08 is

begin
    Q <=  (A AND B) ;

end archTTL08;

--
--	TTL10
--

use work.ttl_local.all;

entity TTL10 is
    port(QN: OUT bit;
         A: IN bit;
         B: IN bit;
         C: IN bit);
end TTL10;

architecture archTTL10 of TTL10 is

begin
    QN <= NOT (A AND B AND C) ;
end archTTL10;

--
--	TTL107
--

use work.ttl_local.all;

entity TTL107 is
    port(J: IN bit;
         K: IN bit;
         CLK: IN bit;
         CLR: IN bit;
         Q: OUT bit;
	 QN: OUT bit);
end TTL107;

architecture archTTL107 of TTL107 is

    signal VL1N7: bit;
    signal VL1N9: bit;

begin
    VL1N9 <= NOT CLK ;

    VL1I27: JKSRFF
        port map(J => K,
                 K => J,
                 S => VL1N7,
                 R => zero,
                 CLK => VL1N9,
                 Q => QN);

    VL1I5: JKSRFF
        port map(J => J,
                 K => K,
                 S => zero,
                 R => VL1N7,
                 CLK => VL1N9,
                 Q => Q);

    VL1N7 <= NOT CLR ;

end archTTL107;

--
--	TTL109
--

use work.ttl_local.all;

entity TTL109 is
    port(PRE: IN bit;
         J: IN bit;
         K: IN bit;
         CLK: IN bit;
         CLR: IN bit;
         Q: OUT bit;
         QN: OUT bit);
end TTL109;

architecture archTTL109 of TTL109 is
    signal VL1N11: bit;
    signal VL1N25: bit;
    signal VL1N7: bit;

begin
    VL1I27: JKSRFF
        port map(J => VL1N11,
                 K => J,
                 S => VL1N7,
                 R => VL1N25,
                 CLK => CLK,
                 Q => QN);

    VL1N25 <= NOT PRE ;

    VL1N11 <= NOT K ;

    VL1I5: JKSRFF
        port map(J => J,
                 K => VL1N11,
                 S => VL1N25,
                 R => VL1N7,
                 CLK => CLK,
                 Q => Q);

    VL1N7 <= NOT CLR ;

end archTTL109;

--
--	TTL11
--

use work.ttl_local.all;

entity TTL11 is
    port(Q: OUT bit;
         A: IN bit;
         B: IN bit;
         C: IN bit);
end TTL11;

architecture archTTL11 of TTL11 is

begin
    Q <= (a and b and c) ;
end archTTL11;

--
--	TTL112
--

use work.ttl_local.all;

entity TTL112 is
    port(PRE: IN bit;
	 J: IN bit;
         K: IN bit;
         CLK: IN bit;
         CLR: IN bit;
         Q: OUT bit;
	 QN: OUT bit);
end TTL112;

architecture archTTL112 of TTL112 is
    signal VL1N25: bit;
    signal VL1N7: bit;
    signal VL1N9: bit;

begin
    VL1N9 <= NOT CLK ;

    VL1I27: JKSRFF
        port map(J => K,
                 K => J,
                 S => VL1N7,
                 R => VL1N25,
                 CLK => VL1N9,
                 Q => QN);

    VL1N25 <= NOT PRE ;

    VL1I5: JKSRFF
        port map(J => J,
                 K => K,
                 S => VL1N25,
                 R => VL1N7,
                 CLK => VL1N9,
                 Q => Q);

    VL1N7 <= NOT CLR ;

end archTTL112;

--
--	TTL113
--

use work.ttl_local.all;

entity TTL113 is
    port(J: IN bit;
         K: IN bit;
         CLK: IN bit;
         PRE: IN bit;
         Q: OUT bit;
	 QN: OUT bit);
end TTL113;

architecture archTTL113 of TTL113 is

    signal VL1N7: bit;
    signal VL1N9: bit;

begin
    VL1N9 <= NOT CLK ;

    VL1I27: JKSRFF
        port map(J => J,
                 K => K,
                 S => VL1N7,
                 R => zero,
                 CLK => VL1N9,
                 Q => Q);

    VL1I5: JKSRFF
        port map(J => K,
                 K => J,
                 S => zero,
                 R => VL1N7,
                 CLK => VL1N9,
                 Q => QN);

    VL1N7 <= NOT PRE ;

end archTTL113;

--
--	TTL116
--

use work.ttl_local.all;

entity TTL116 is
    port(CLR: IN bit;
         C1: IN bit;
         C2: IN bit;
         D1: IN bit;
         D2: IN bit;
         D3: IN bit;
         D4: IN bit;
         Q1: OUT bit;
         Q2: OUT bit;
         Q3: OUT bit;
         Q4: OUT bit);
end TTL116;

architecture archTTL116 of TTL116 is

    signal E116: bit;
    signal RST116: bit;

begin
    VL1I1: DSRLCH
        port map(D => D1,
                 S => zero,
                 R => RST116,
                 E => E116,
                 Q => Q1);

    E116 <=  NOT (C1 OR C2) ;

    RST116 <= NOT CLR ;

    VL1I2: DSRLCH
        port map(D => D2,
                 S => zero,
                 R => RST116,
                 E => E116,
                 Q => Q2);

    VL1I3: DSRLCH
        port map(D => D3,
                 S => zero,
                 R => RST116,
                 E => E116,
                 Q => Q3);

    VL1I4: DSRLCH
        port map(D => D4,
                 S => zero,
                 R => RST116,
                 E => E116,
                 Q => Q4);

end archTTL116;

--
--	TTL125
--

use work.ttl_local.all;

entity TTL125 is
    port(G: IN bit;
         A: IN bit;
         Y: OUT x01z);
end TTL125;

architecture archTTL125 of TTL125 is
    signal VL1N10: bit;

begin
    VL1I1: TRIOUT
        port map(X => A,
                 OE => VL1N10,
                 Y => Y);

    VL1N10 <= NOT G ;

end archTTL125;

--
--	TTL126
--

use work.ttl_local.all;

entity TTL126 is
    port(G: IN bit;
         A: IN bit;
         Y: OUT x01z);
end TTL126;

architecture archTTL126 of TTL126 is

begin
    VL1I1: TRIOUT
        port map(X => A,
                 OE => G,
                 Y => Y);

end archTTL126;

--
--	TTL138
--

use work.ttl_local.all;

entity TTL138 is
    port(G1: IN bit;
         G2A: IN bit;
         G2B: IN bit;
         A: IN bit;
         B: IN bit;
         C: IN bit;
         Y0: OUT bit;
	 Y1: OUT bit;
         Y2: OUT bit;
         Y3: OUT bit;
         Y4: OUT bit;
         Y5: OUT bit;
         Y6: OUT bit;
         Y7: OUT bit);
end TTL138;

architecture archTTL138 of TTL138 is
    signal VL1N126: bit;
    signal VL1N131: bit;
    signal VL1N150: bit;
    signal VL1N27: bit;
    signal VL1N28: bit;
    signal VL1N29: bit;
    signal VL1N31: bit;
    signal VL1N32: bit;
    signal VL1N33: bit;
    signal VL1N34: bit;

begin
    VL1I114: DE3X8
        port map(EN => VL1N126,
                 S0 => A,
                 S1 => B,
                 S2 => C,
                 Y0 => VL1N27,
                 Y1 => VL1N28,
                 Y2 => VL1N29,
                 Y3 => VL1N150,
                 Y4 => VL1N31,
                 Y5 => VL1N32,
                 Y6 => VL1N33,
                 Y7 => VL1N34);

    VL1N131 <= NOT G1 ;

    VL1N126 <= NOT (VL1N131 OR G2A OR G2B) ;

    Y0 <= NOT VL1N27 ;

    Y1 <= NOT VL1N28 ;

    Y2 <= NOT VL1N29 ;

    Y3 <= NOT VL1N150 ;

    Y4 <= NOT VL1N31 ;

    Y5 <= NOT VL1N32 ;

    Y6 <= NOT VL1N33 ;

    Y7 <= NOT VL1N34 ;

end archTTL138;

--
--	TTL139
--

use work.ttl_local.all;

entity TTL139 is
    port(G: IN bit;
         A: IN bit;
	 B: IN bit;
         Y0: OUT bit;
         Y1: OUT bit;
         Y2: OUT bit;
         Y3: OUT bit);
end TTL139;

architecture archTTL139 of TTL139 is
    signal EN: bit;
    signal YT0: bit;
    signal YT1: bit;
    signal YT2: bit;
    signal YT3: bit;

begin
    VL1I1: DE2X4
        port map(EN => EN,
                 S0 => A,
                 S1 => B,
                 Y0 => YT0,
                 Y1 => YT1,
                 Y2 => YT2,
                 Y3 => YT3);

    EN <= NOT G ;

    Y1 <= NOT YT1 ;

    Y0 <= NOT YT0 ;

    Y3 <= NOT YT3 ;

    Y2 <= NOT YT2 ;

end archTTL139;

--
--	TTL150
--

use work.ttl_local.all;

entity TTL150 is
    port(G: IN bit;
         A: IN bit;
         B: IN bit;
         C: IN bit;
         D: IN bit;
         E0: IN bit;
         E1: IN bit;
         E2: IN bit;
         E3: IN bit;
         E4: IN bit;
         E5: IN bit;
         E6: IN bit;
         E7: IN bit;
         E8: IN bit;
         E9: IN bit;
         E10: IN bit;
         E11: IN bit;
         E12: IN bit;
         E13: IN bit;
         E14: IN bit;
         E15: IN bit;
	 W: OUT bit);
end TTL150;

architecture archTTL150 of TTL150 is
    signal VL1N64: bit;
    signal VL1N66: bit;

begin
    VL1I1: MUX1OF16
        port map(EN => VL1N64,
                 S0 => A,
                 S1 => B,
                 S2 => C,
                 S3 => D,
                 D0 => E0,
                 D1 => E1,
                 D2 => E2,
                 D3 => E3,
                 D4 => E4,
                 D5 => E5,
                 D6 => E6,
                 D7 => E7,
                 D8 => E8,
                 D9 => E9,
                 D10 => E10,
                 D11 => E11,
                 D12 => E12,
                 D13 => E13,
                 D14 => E14,
                 D15 => E15,
                 Y => VL1N66);

    W <= NOT VL1N66 ;

    VL1N64 <= NOT G ;

end archTTL150;

--
--	TTL151
--

use work.ttl_local.all;

entity TTL151 is
    port(D0: IN bit;
         D1: IN bit;
         D2: IN bit;
         D3: IN bit;
         D4: IN bit;
         D5: IN bit;
	 D6: IN bit;
         D7: IN bit;
         G: IN bit;
         A: IN bit;
         B: IN bit;
         C: IN bit;
         Y: OUT bit;
         W: OUT bit);
end TTL151;

architecture archTTL151 of TTL151 is

    signal VL1N56, ytmp: bit;

begin
    VL1I1: MUX1OF8
        port map(EN => VL1N56,
                 S0 => A,
                 S1 => B,
                 S2 => C,
                 D0 => D0,
                 D1 => D1,
                 D2 => D2,
                 D3 => D3,
                 D4 => D4,
                 D5 => D5,
                 D6 => D6,
                 D7 => D7,
                 Y => YTMP);

    Y <= YTMP;

    W <= NOT YTMP ;

    VL1N56 <= NOT G ;

end archTTL151;

--
--	TTL153
--

use work.ttl_local.all;

entity TTL153 is
    port(C0: IN bit;
         C1: IN bit;
         C2: IN bit;
         C3: IN bit;
         G: IN bit;
         A: IN bit;
         B: IN bit;
         Y: OUT bit);
end TTL153;

architecture archTTL153 of TTL153 is
    signal VL1N15: bit;

begin
    VL1I1: MUX1OF4
        port map(EN => VL1N15,
                 S0 => A,
                 S1 => B,
                 D0 => C0,
                 D1 => C1,
                 D2 => C2,
                 D3 => C3,
                 Y => Y);

    VL1N15 <= NOT G ;

end archTTL153;

--
--	TTL154
--

use work.ttl_local.all;

entity TTL154 is
    port(G1: IN bit;
         G2: IN bit;
         A: IN bit;
         B: IN bit;
         C: IN bit;
         D: IN bit;
	 Y0: OUT bit;
         Y1: OUT bit;
         Y2: OUT bit;
         Y3: OUT bit;
         Y4: OUT bit;
         Y5: OUT bit;
         Y6: OUT bit;
         Y7: OUT bit;
         Y8: OUT bit;
         Y9: OUT bit;
         Y10: OUT bit;
         Y11: OUT bit;
         Y12: OUT bit;
         Y13: OUT bit;
         Y14: OUT bit;
         Y15: OUT bit);
end TTL154;

architecture archTTL154 of TTL154 is
    signal VL1N100: bit;
    signal VL1N102: bit;
    signal VL1N104: bit;
    signal VL1N106: bit;
    signal VL1N108: bit;
    signal VL1N110: bit;
    signal VL1N112: bit;
    signal VL1N114: bit;
    signal VL1N116: bit;
    signal VL1N118: bit;
    signal VL1N120: bit;
    signal VL1N72: bit;
    signal VL1N90: bit;
    signal VL1N92: bit;
    signal VL1N94: bit;
    signal VL1N96: bit;
    signal VL1N98: bit;

begin
    VL1I2: DE4X16
        port map(EN => VL1N72,
                 S0 => A,
                 S1 => B,
                 S2 => C,
                 S3 => D,
                 Y0 => VL1N90,
                 Y1 => VL1N92,
                 Y2 => VL1N94,
                 Y3 => VL1N96,
                 Y4 => VL1N98,
                 Y5 => VL1N100,
                 Y6 => VL1N102,
                 Y7 => VL1N104,
                 Y8 => VL1N106,
                 Y9 => VL1N108,
                 Y10 => VL1N110,
                 Y11 => VL1N112,
                 Y12 => VL1N114,
                 Y13 => VL1N116,
                 Y14 => VL1N118,
                 Y15 => VL1N120);

    VL1N72 <=  NOT (G1 OR G2) ;

    Y0 <= NOT VL1N90 ;

    Y1 <= NOT VL1N92 ;

    Y2 <= NOT VL1N94 ;

    Y3 <= NOT VL1N96 ;

    Y4 <= NOT VL1N98 ;

    Y5 <= NOT VL1N100 ;

    Y6 <= NOT VL1N102 ;

    Y7 <= NOT VL1N104 ;

    Y8 <= NOT VL1N106 ;

    Y9 <= NOT VL1N108 ;

    Y10 <= NOT VL1N110 ;

    Y11 <= NOT VL1N112 ;

    Y12 <= NOT VL1N114 ;

    Y13 <= NOT VL1N116 ;

    Y15 <= NOT VL1N120 ;

    Y14 <= NOT VL1N118 ;

end archTTL154;

--
--	TTL157
--

use work.ttl_local.all;

entity TTL157 is
    port(A: IN bit;
         B: IN bit;
         G: IN bit;
         S: IN bit;
	 Y: OUT bit);
end TTL157;

architecture archTTL157 of TTL157 is
    signal VL1N29: bit;

begin
    VL1I1: MUX1OF2
        port map(EN => VL1N29,
                 S => S,
                 D0 => A,
                 D1 => B,
                 Y => Y);

    VL1N29 <= NOT G ;

end archTTL157;

--
--	TTL158
--

use work.ttl_local.all;

entity TTL158 is
    port(A: IN bit;
         B: IN bit;
         G: IN bit;
         S: IN bit;
	 Y: OUT bit);
end TTL158;

architecture archTTL158 of TTL158 is
    signal VL1N26: bit;
    signal VL1N30: bit;

begin
    VL1I1: MUX1OF2
        port map(EN => VL1N30,
                 S => S,
                 D0 => A,
                 D1 => B,
                 Y => VL1N26);

    Y <= NOT VL1N26 ;

    VL1N30 <= NOT G ;

end archTTL158;

--
--	TTL160
--

use work.ttl_local.all;

entity TTL160 is
    port(ENT: IN bit;
         ENP: IN bit;
         LD: IN bit;
         A: IN bit;
         B: IN bit;
         C: IN bit;
         D: IN bit;
         CLK: IN bit;
         CLR: IN bit;
         RCO: OUT bit;
         QA: OUT bit;
	 QB: OUT bit;
         QC: OUT bit;
         QD: OUT bit);
end TTL160;

architecture archTTL160 of TTL160 is
    signal VL1N137: bit;
    signal D0: bit;
    signal D1: bit;
    signal D2: bit;
    signal D3: bit;
    signal L: bit;
    signal LOADT: bit;
    signal MAXCNT: bit;
    signal Q1N: bit;
    signal Q2N: bit;
    signal R: bit;
    signal qatmp,qbtmp,qctmp,qdtmp : bit;

begin

    QA <= qatmp;
    QB <= qbtmp;
    QC <= qctmp;
    QD <= qdtmp;

    VL1I1: CNTR4
        port map(CI => ENT,
                 CO => OPEN,
                 EN => ENP,
                 L => L,
                 D3 => D3,
                 D2 => D2,
                 D1 => D1,
                 D0 => D0,
                 CLK => CLK,
                 R => R,
                 Q3 => qdtmp,
                 Q2 => qctmp,
                 Q1 => qbtmp,
                 Q0 => qatmp);

    L <=  (LOADT OR VL1N137) ;

    LOADT <= NOT LD ;

    RCO <=  (ENT AND MAXCNT) ;

    VL1N137 <= ENT and ENP and MAXCNT ;

    R <= NOT CLR ;

    MAXCNT <= qatmp and Q1N and Q2N and qdtmp ;

    D0 <=  (LOADT AND A) ;

    Q2N <= NOT qctmp ;

    Q1N <= NOT qbtmp ;

    D1 <=  (LOADT AND B) ;

    D2 <=  (LOADT AND C) ;

    D3 <=  (LOADT AND D) ;

end archTTL160;

--
--	TTL161
--

use work.ttl_local.all;

entity TTL161 is
    port(ENT: IN bit;
         ENP: IN bit;
         LD: IN bit;
         A: IN bit;
         B: IN bit;
         C: IN bit;
         D: IN bit;
         CLK: IN bit;
         CLR: IN bit;
         RCO: OUT bit;
         QA: OUT bit;
	 QB: OUT bit;
         QC: OUT bit;
         QD: OUT bit);
end TTL161;

architecture archTTL161 of TTL161 is
    signal L: bit;
    signal R: bit;

begin
    VL1I1: CNTR4
        port map(CI => ENT,
                 CO => RCO,
                 EN => ENP,
                 L => L,
                 D3 => D,
                 D2 => C,
                 D1 => B,
                 D0 => A,
                 CLK => CLK,
                 R => R,
                 Q3 => QD,
                 Q2 => QC,
                 Q1 => QB,
                 Q0 => QA);

    L <= NOT LD ;

    R <= NOT CLR ;

end archTTL161;

--
--	TTL162
--

use work.ttl_local.all;

entity TTL162 is
    port(ENT: IN bit;
         ENP: IN bit;
         LD: IN bit;
         A: IN bit;
         B: IN bit;
         C: IN bit;
         D: IN bit;
         CLK: IN bit;
         CLR: IN bit;
         RCO: OUT bit;
         QA: OUT bit;
	 QB: OUT bit;
         QC: OUT bit;
         QD: OUT bit);
end TTL162;

architecture archTTL162 of TTL162 is

    signal VL1N150: bit;
    signal VL1N155: bit;
    signal VL1N172: bit;
    signal VL1N182: bit;
    signal D0: bit;
    signal D1: bit;
    signal D2: bit;
    signal D3: bit;
    signal DEN: bit;
    signal LT: bit;
    signal MAXCNT: bit;
    signal Q1N: bit;
    signal Q2N: bit;
    signal qatmp,qbtmp,qctmp,qdtmp : bit;

begin

    QA <= qatmp;
    QB <= qbtmp;
    QC <= qctmp;
    QD <= qdtmp;

    VL1I1: CNTR4
        port map(CI => ENT,
                 CO => OPEN,
                 EN => ENP,
                 L => LT,
                 D3 => D3,
                 D2 => D2,
                 D1 => D1,
                 D0 => D0,
                 CLK => CLK,
                 R => zero,
                 Q3 => qdtmp,
                 Q2 => qctmp,
                 Q1 => qbtmp,
                 Q0 => qatmp);

    VL1N150 <= NOT LD ;

    DEN <=  (VL1N150 AND CLR) ;

    VL1N155 <= NOT CLR ;

    VL1N172 <=  (VL1N150 OR VL1N155) ;

    LT <=  (VL1N172 OR VL1N182) ;

    RCO <=  (ENT AND MAXCNT) ;

    VL1N182 <= ENT and ENP and MAXCNT ;
    MAXCNT <= qatmp and Q1N and Q2N and qdtmp ;

    Q2N <= NOT qctmp ;

    Q1N <= NOT qbtmp ;

    D0 <=  (A AND DEN) ;

    D1 <=  (B AND DEN) ;

    D2 <=  (C AND DEN) ;

    D3 <=  (D AND DEN) ;

end archTTL162;

--
--	TTL163
--

use work.ttl_local.all;

entity TTL163 is
    port(ENT: IN bit;
         ENP: IN bit;
         LD: IN bit;
         A: IN bit;
         B: IN bit;
         C: IN bit;
         D: IN bit;
         CLK: IN bit;
         CLR: IN bit;
         RCO: OUT bit;
         QA: OUT bit;
	 QB: OUT bit;
         QC: OUT bit;
         QD: OUT bit);
end TTL163;

architecture archTTL163 of TTL163 is

    signal CLEAR: bit;
    signal D0: bit;
    signal D1: bit;
    signal D2: bit;
    signal D3: bit;
    signal L: bit;
    signal LOAD: bit;

begin
    VL1I1: CNTR4
        port map(CI => ENT,
                 CO => RCO,
                 EN => ENP,
                 L => L,
                 D3 => D3,
                 D2 => D2,
                 D1 => D1,
                 D0 => D0,
                 CLK => CLK,
                 R => zero,
                 Q3 => QD,
                 Q2 => QC,
                 Q1 => QB,
                 Q0 => QA);

    CLEAR <= NOT CLR ;

    LOAD <= NOT LD ;

    D0 <=  (A AND CLR) ;

    D1 <=  (B AND CLR) ;

    D2 <=  (C AND CLR) ;

    D3 <=  (D AND CLR) ;

    L <=  (LOAD OR CLEAR) ;

end archTTL163;

--
--	TTL168
--

use work.ttl_local.all;

entity TTL168 is
    port(ENT: IN bit;
         ENP: IN bit;
         LD: IN bit;
         UP: IN bit;
         A: IN bit;
         B: IN bit;
         C: IN bit;
         D: IN bit;
         CLK: IN bit;
         RCO: OUT bit;
         QA: OUT bit;
	 QB: OUT bit;
         QC: OUT bit;
         QD: OUT bit);
end TTL168;

architecture archTTL168 of TTL168 is

    signal VL1N298: bit;
    signal C0: bit;
    signal C9: bit;
    signal ENPH: bit;
    signal ENTH: bit;
    signal LD0: bit;
    signal LD1: bit;
    signal LD2: bit;
    signal LD3: bit;
    signal LOAD: bit;
    signal LT: bit;
    signal Q1N: bit;
    signal Q2N: bit;
    signal RCOH: bit;
    signal qatmp,qbtmp,qctmp,qdtmp : bit;

begin

    QA <= qatmp;
    QB <= qbtmp;
    QC <= qctmp;
    QD <= qdtmp;

    VL1I176: MUX1OF2
        port map(EN => one,
                 S => LOAD,
                 D0 => C0,
                 D1 => A,
                 Y => LD0);

    C9 <= qatmp and qdtmp and Q1N and Q2N ;

    Q1N <= NOT qbtmp ;

    Q2N <= NOT qctmp ;

    C0 <= NOT (qatmp OR qbtmp OR qctmp OR qdtmp) ;

    VL1I212: MUX1OF2
        port map(EN => one,
                 S => LOAD,
                 D0 => C0,
                 D1 => D,
                 Y => LD3);

    VL1I282: MUX1OF2
        port map(EN => one,
                 S => UP,
                 D0 => C0,
                 D1 => C9,
                 Y => RCOH);

    LOAD <= NOT LD ;

    LT <=  (LOAD OR VL1N298) ;

    LD1 <=  (B AND LOAD) ;

    LD2 <=  (C AND LOAD) ;

    ENPH <= NOT ENP ;

    ENTH <= NOT ENT ;

    RCO <= NOT (ENTH AND RCOH) ;

    VL1N298 <= ENTH and ENPH and RCOH ;

    VL1I57: UPDN4
        port map(CI => ENTH,
                 CO => OPEN,
                 UP => UP,
                 EN => ENPH,
                 L => LT,
                 D3 => LD3,
                 D2 => LD2,
                 D1 => LD1,
                 D0 => LD0,
                 CLK => CLK,
                 R => zero,
                 Q3 => qdtmp,
                 Q2 => qctmp,
                 Q1 => qbtmp,
                 Q0 => qatmp);

end archTTL168;

--
--	TTL169
--

use work.ttl_local.all;

entity TTL169 is
    port(ENT: IN bit;
         ENP: IN bit;
         LD: IN bit;
         UP: IN bit;
         A: IN bit;
         B: IN bit;
         C: IN bit;
         D: IN bit;
         CLK: IN bit;
         RCO: OUT bit;
         QA: OUT bit;
	 QB: OUT bit;
         QC: OUT bit;
         QD: OUT bit);
end TTL169;

architecture archTTL169 of TTL169 is

    signal VL1N85: bit;
    signal CI: bit;
    signal EN: bit;
    signal L: bit;

begin
    L <= NOT LD ;

    VL1I57: UPDN4
        port map(CI => CI,
                 CO => VL1N85,
                 UP => UP,
                 EN => EN,
                 L => L,
                 D3 => D,
                 D2 => C,
                 D1 => B,
                 D0 => A,
                 CLK => CLK,
                 R => zero,
                 Q3 => QD,
                 Q2 => QC,
                 Q1 => QB,
                 Q0 => QA);

    EN <= NOT ENP ;

    CI <= NOT ENT ;

    RCO <= NOT VL1N85 ;

end archTTL169;

--
--	TTL173
--

use work.ttl_local.all;

entity TTL173 is
    port(M: IN bit;
         N: IN bit;
         G1: IN bit;
         G2: IN bit;
	 D1: IN bit;
         D2: IN bit;
         D3: IN bit;
         D4: IN bit;
         CLK: IN bit;
         CLR: IN bit;
         Q1: OUT x01z;
         Q2: OUT x01z;
         Q3: OUT x01z;
         Q4: OUT x01z);
end TTL173;

architecture archTTL173 of TTL173 is
    signal ENT: bit;
    signal OE: bit;
    signal RQ0: bit;
    signal RQ1: bit;
    signal RQ2: bit;
    signal RQ3: bit;

begin
    VL1I1: REG4
        port map(D3 => D4,
                 D2 => D3,
                 D1 => D2,
                 D0 => D1,
                 EN => ENT,
                 CLK => CLK,
                 R => CLR,
                 Q3 => RQ3,
                 Q2 => RQ2,
                 Q1 => RQ1,
                 Q0 => RQ0);

    OE <=  NOT (M OR N) ;

    VL1I4: TRIOUT
        port map(X => RQ0,
                 OE => OE,
                 Y => Q1);

    VL1I5: TRIOUT
        port map(X => RQ1,
                 OE => OE,
                 Y => Q2);

    VL1I6: TRIOUT
        port map(X => RQ2,
                 OE => OE,
                 Y => Q3);

    VL1I7: TRIOUT
        port map(X => RQ3,
                 OE => OE,
                 Y => Q4);

    ENT <=  NOT (G1 OR G2) ;

end archTTL173;

--
--	TTL174
--

use work.ttl_local.all;

entity TTL174 is
    port(D1: IN bit;
         D2: IN bit;
         D3: IN bit;
         D4: IN bit;
         D5: IN bit;
         D6: IN bit;
         CLK: IN bit;
         CLR: IN bit;
	 Q1: OUT bit;
         Q2: OUT bit;
         Q3: OUT bit;
         Q4: OUT bit;
         Q5: OUT bit;
         Q6: OUT bit);
end TTL174;

architecture archTTL174 of TTL174 is

    signal VL1N16: bit;

begin
    VL1I1: DSRFF
        port map(D => D1,
                 S => zero,
                 R => VL1N16,
                 CLK => CLK,
                 Q => Q1);

    VL1N16 <= NOT CLR ;

    VL1I2: DSRFF
        port map(D => D2,
                 S => zero,
                 R => VL1N16,
                 CLK => CLK,
                 Q => Q2);

    VL1I3: DSRFF
        port map(D => D3,
                 S => zero,
                 R => VL1N16,
                 CLK => CLK,
                 Q => Q3);

    VL1I4: DSRFF
        port map(D => D4,
                 S => zero,
                 R => VL1N16,
                 CLK => CLK,
                 Q => Q4);

    VL1I5: DSRFF
        port map(D => D5,
                 S => zero,
                 R => VL1N16,
                 CLK => CLK,
                 Q => Q5);

    VL1I6: DSRFF
        port map(D => D6,
                 S => zero,
                 R => VL1N16,
                 CLK => CLK,
                 Q => Q6);

end archTTL174;

--
--	TTL175
--

use work.ttl_local.all;

entity TTL175 is
    port(D1: IN bit;
         D2: IN bit;
         D3: IN bit;
         D4: IN bit;
         CLK: IN bit;
         CLR: IN bit;
         Q1:  OUT bit;
	 Q1N: OUT bit;
         Q2:  OUT bit;
         Q2N: OUT bit;
         Q3:  OUT bit;
         Q3N: OUT bit;
         Q4:  OUT bit;
         Q4N: OUT bit);
end TTL175;

architecture archTTL175 of TTL175 is

    signal VL1N101: bit;
    signal VL1N16: bit;
    signal VL1N82: bit;
    signal VL1N85: bit;
    signal VL1N89: bit;

begin
    VL1I1: DSRFF
        port map(D => D1,
                 S => zero,
                 R => VL1N16,
                 CLK => CLK,
                 Q => Q1);

    VL1N16 <= NOT CLR ;

    VL1I124: DSRFF
        port map(D => VL1N85,
                 S => VL1N16,
                 R => zero,
                 CLK => CLK,
                 Q => Q2N);

    VL1I125: DSRFF
        port map(D => VL1N101,
                 S => VL1N16,
                 R => zero,
                 CLK => CLK,
                 Q => Q4N);

    VL1I126: DSRFF
        port map(D => VL1N89,
                 S => VL1N16,
                 R => zero,
                 CLK => CLK,
                 Q => Q3N);

    VL1I127: DSRFF
        port map(D => VL1N82,
                 S => VL1N16,
                 R => zero,
                 CLK => CLK,
                 Q => Q1N);

    VL1I2: DSRFF
        port map(D => D2,
                 S => zero,
                 R => VL1N16,
                 CLK => CLK,
                 Q => Q2);

    VL1I3: DSRFF
        port map(D => D3,
                 S => zero,
                 R => VL1N16,
                 CLK => CLK,
                 Q => Q3);

    VL1I6: DSRFF
        port map(D => D4,
                 S => zero,
                 R => VL1N16,
                 CLK => CLK,
                 Q => Q4);

    VL1N101 <= NOT D4 ;

    VL1N89 <= NOT D3 ;

    VL1N85 <= NOT D2 ;

    VL1N82 <= NOT D1 ;

end archTTL175;

--
--	TTL190
--

use work.ttl_local.all;

entity TTL190 is
    port(CTEN: IN bit;
         DOWN: IN bit;
         LOAD: IN bit;
         A: IN bit;
         B: IN bit;
         C: IN bit;
         D: IN bit;
         CLK: IN bit;
         RCO: OUT bit;
         MM: OUT bit;
         QA: OUT bit;
         QB: OUT bit;
         QC: OUT bit;
	 QD: OUT bit);
end TTL190;

architecture archTTL190 of TTL190 is

    signal VL1N102: bit;
    signal VL1N158: bit;
    signal VL1N161: bit;
    signal VL1N167: bit;
    signal VL1N191: bit;
    signal VL1N193: bit;
    signal VL1N195: bit;
    signal VL1N209: bit;
    signal VL1N210: bit;
    signal VL1N212: bit;
    signal VL1N214: bit;
    signal VL1N229: bit;
    signal VL1N231: bit;
    signal VL1N232: bit;
    signal VL1N282: bit;
    signal VL1N337: bit;
    signal VL1N395: bit;
    signal VL1N425: bit;
    signal VL1N428: bit;
    signal VL1N458: bit;
    signal VL1N460: bit;
    signal VL1N467: bit;
    signal VL1N469: bit;
    signal VL1N478: bit;
    signal VL1N480: bit;
    signal VL1N506: bit;
    signal VL1N514: bit;
    signal VL1N516: bit;
    signal VL1N564: bit;
    signal VL1N578: bit;
    signal VL1N579: bit;
    signal VL1N581: bit;
    signal VL1N584: bit;
    signal VL1N588: bit;
    signal VL1N590: bit;
    signal VL1N600: bit;
    signal VL1N601: bit;
    signal VL1N603: bit;
    signal VL1N606: bit;
    signal CI: bit;
    signal qatmp,qbtmp,qctmp,qdtmp,mmtmp : bit;

begin

    QA <= qatmp;
    QB <= qbtmp;
    QC <= qctmp;
    QD <= qdtmp;
    MM <= mmtmp;

    VL1N102 <= NOT CLK ;

    CI <= NOT CTEN ;

    VL1I134: DSRFF
        port map(D => VL1N578,
                 S => VL1N161,
                 R => VL1N158,
                 CLK => CLK,
                 Q => qatmp);

    VL1N158 <=  NOT (LOAD OR A) ;

    VL1N161 <=  NOT (VL1N167 OR LOAD) ;

    VL1N167 <= NOT A ;

    VL1N606 <= NOT qatmp ;

    VL1N195 <= NOT B ;

    VL1N191 <=  NOT (LOAD OR B) ;

    VL1I190: DSRFF
        port map(D => VL1N425,
                 S => VL1N193,
                 R => VL1N191,
                 CLK => CLK,
                 Q => qbtmp);

    VL1N193 <=  NOT (VL1N195 OR LOAD) ;

    VL1N603 <= NOT qbtmp ;

    VL1N601 <= NOT qctmp ;

    VL1N210 <=  NOT (VL1N209 OR LOAD) ;

    VL1I213: DSRFF
        port map(D => VL1N214,
                 S => VL1N210,
                 R => VL1N212,
                 CLK => CLK,
                 Q => qctmp);

    VL1N212 <=  NOT (LOAD OR C) ;

    VL1N209 <= NOT C ;

    VL1N232 <= NOT D ;

    VL1N229 <=  NOT (LOAD OR D) ;

    VL1I228: DSRFF
        port map(D => VL1N584,
                 S => VL1N231,
                 R => VL1N229,
                 CLK => CLK,
                 Q => qdtmp);

    VL1N231 <=  NOT (VL1N232 OR LOAD) ;

    VL1N600 <= NOT qdtmp ;

    VL1I399: MUX1OF2
        port map(EN => one,
                 S => DOWN,
                 D0 => VL1N395,
                 D1 => VL1N581,
                 Y => mmtmp);

    VL1N581 <= NOT (qdtmp OR qctmp OR qbtmp OR qatmp) ;

    VL1N395 <= (qdtmp AND VL1N514 AND VL1N516 AND qatmp) ;

    VL1I430: MUX1OF2
        port map(EN => VL1N506,
                 S => CI,
                 D0 => qatmp,
                 D1 => VL1N606,
                 Y => VL1N579);

    VL1I436: MUX1OF2
        port map(EN => VL1N506,
                 S => VL1N428,
                 D0 => qbtmp,
                 D1 => VL1N603,
                 Y => VL1N425);

    VL1I440: MUX1OF2
        port map(EN => VL1N506,
                 S => VL1N282,
                 D0 => qctmp,
                 D1 => VL1N601,
                 Y => VL1N214);

    VL1I445: MUX1OF2
        port map(EN => VL1N506,
                 S => VL1N337,
                 D0 => qdtmp,
                 D1 => VL1N600,
                 Y => VL1N588);

    VL1I450: MUX1OF2
        port map(EN => one,
                 S => DOWN,
                 D0 => VL1N458,
                 D1 => VL1N460,
                 Y => VL1N428);

    VL1N458 <=  (qatmp AND CI) ;

    VL1N467 <= CI and qatmp and qbtmp ;

    VL1N460 <=  (VL1N606 AND CI) ;

    VL1N469 <= CI and VL1N606 and VL1N603 ;

    VL1I465: MUX1OF2
        port map(EN => one,
                 S => DOWN,
                 D0 => VL1N467,
                 D1 => VL1N469,
                 Y => VL1N282);

    VL1N478 <= qctmp and qbtmp and qatmp and CI ;

    VL1N480 <= VL1N601 and VL1N603 and VL1N606 and CI ;

    VL1I476: MUX1OF2
        port map(EN => one,
                 S => DOWN,
                 D0 => VL1N478,
                 D1 => VL1N480,
                 Y => VL1N337);

    VL1N506 <= NOT (CI AND mmtmp) ;

    RCO <= NOT (VL1N102 AND CI AND VL1N564) ;

    VL1N514 <= NOT qbtmp ;

    VL1N516 <= NOT qctmp ;

    VL1N564 <= NOT VL1N506 ;

    VL1N578 <=  (VL1N579 OR VL1N590) ;

    VL1N584 <=  (VL1N588 OR VL1N590) ;

    VL1N590 <=  (VL1N564 AND VL1N581) ;

end archTTL190;

--
--	TTL191
--

use work.ttl_local.all;

entity TTL191 is
    port(CTEN: IN bit;
         DOWN: IN bit;
         LOAD: IN bit;
         A: IN bit;
         B: IN bit;
         C: IN bit;
         D: IN bit;
         CLK: IN bit;
         RCO: OUT bit;
         MM: OUT bit;
         QA: OUT bit;
         QB: OUT bit;
         QC: OUT bit;
	 QD: OUT bit);
end TTL191;

architecture archTTL191 of TTL191 is

    signal VL1N102: bit;
    signal VL1N158: bit;
    signal VL1N161: bit;
    signal VL1N167: bit;
    signal VL1N191: bit;
    signal VL1N193: bit;
    signal VL1N195: bit;
    signal VL1N209: bit;
    signal VL1N210: bit;
    signal VL1N212: bit;
    signal VL1N214: bit;
    signal VL1N227: bit;
    signal VL1N229: bit;
    signal VL1N231: bit;
    signal VL1N232: bit;
    signal VL1N28: bit;
    signal VL1N282: bit;
    signal VL1N337: bit;
    signal VL1N395: bit;
    signal VL1N396: bit;
    signal VL1N417: bit;
    signal VL1N418: bit;
    signal VL1N420: bit;
    signal VL1N425: bit;
    signal VL1N428: bit;
    signal VL1N441: bit;
    signal VL1N446: bit;
    signal VL1N458: bit;
    signal VL1N460: bit;
    signal VL1N467: bit;
    signal VL1N469: bit;
    signal VL1N478: bit;
    signal VL1N480: bit;
    signal VL1N489: bit;
    signal VL1N494: bit;
    signal CI: bit;
    signal qatmp,qbtmp,qctmp,qdtmp : bit;

begin

    QA <= qatmp;
    QB <= qbtmp;
    QC <= qctmp;
    QD <= qdtmp;

    VL1N102 <= NOT CLK ;

    CI <= NOT CTEN ;

    VL1I134: DSRFF
        port map(D => VL1N420,
                 S => VL1N161,
                 R => VL1N158,
                 CLK => CLK,
                 Q => qatmp);

    VL1N158 <=  NOT (LOAD OR A) ;

    VL1N161 <=  NOT (VL1N167 OR LOAD) ;

    VL1N167 <= NOT A ;

    VL1N417 <= NOT qatmp ;

    VL1N195 <= NOT B ;

    VL1N191 <=  NOT (LOAD OR B) ;

    VL1I190: DSRFF
        port map(D => VL1N425,
                 S => VL1N193,
                 R => VL1N191,
                 CLK => CLK,
                 Q => qbtmp);

    VL1N193 <=  NOT (VL1N195 OR LOAD) ;

    VL1N418 <= NOT qbtmp ;

    VL1N441 <= NOT qctmp ;

    VL1N210 <=  NOT (VL1N209 OR LOAD) ;

    VL1I213: DSRFF
        port map(D => VL1N214,
                 S => VL1N210,
                 R => VL1N212,
                 CLK => CLK,
                 Q => qctmp);

    VL1N212 <=  NOT (LOAD OR C) ;

    VL1N209 <= NOT C ;

    VL1N232 <= NOT D ;

    VL1N229 <=  NOT (LOAD OR D) ;

    VL1I228: DSRFF
        port map(D => VL1N227,
                 S => VL1N231,
                 R => VL1N229,
                 CLK => CLK,
                 Q => qdtmp);

    VL1N231 <=  NOT (VL1N232 OR LOAD) ;

    VL1N446 <= NOT qdtmp ;

    VL1I399: MUX1OF2
        port map(EN => one,
                 S => DOWN,
                 D0 => VL1N395,
                 D1 => VL1N396,
                 Y => MM);

    VL1N396 <= NOT (qdtmp OR qctmp OR qbtmp OR qatmp) ;
    VL1N395 <= (qdtmp AND qctmp AND qbtmp AND qatmp) ;

    VL1I430: MUX1OF2
        port map(EN => one,
                 S => CI,
                 D0 => qatmp,
                 D1 => VL1N417,
                 Y => VL1N420);

    VL1I436: MUX1OF2
        port map(EN => one,
                 S => VL1N428,
                 D0 => qbtmp,
                 D1 => VL1N418,
                 Y => VL1N425);

    VL1I440: MUX1OF2
        port map(EN => one,
                 S => VL1N282,
                 D0 => qctmp,
                 D1 => VL1N441,
                 Y => VL1N214);

    VL1I445: MUX1OF2
        port map(EN => one,
                 S => VL1N337,
                 D0 => qdtmp,
                 D1 => VL1N446,
                 Y => VL1N227);

    VL1I450: MUX1OF2
        port map(EN => one,
                 S => DOWN,
                 D0 => VL1N458,
                 D1 => VL1N460,
                 Y => VL1N428);

    VL1N458 <=  (qatmp AND CI) ;

    VL1N467 <= qbtmp and qatmp and CI ;

    VL1N460 <=  (VL1N417 AND CI) ;

    VL1N469 <= VL1N418 and VL1N417 and CI ;

    VL1I465: MUX1OF2
        port map(EN => one,
                 S => DOWN,
                 D0 => VL1N467,
                 D1 => VL1N469,
                 Y => VL1N282);

    VL1N478 <= qctmp and qbtmp and qatmp and CI ;

    VL1N480 <= VL1N441 and VL1N418 and VL1N417 and CI ;

    VL1I476: MUX1OF2
        port map(EN => one,
                 S => DOWN,
                 D0 => VL1N478,
                 D1 => VL1N480,
                 Y => VL1N337);

    VL1I482: MUX1OF2
        port map(EN => one,
                 S => DOWN,
                 D0 => VL1N489,
                 D1 => VL1N494,
                 Y => VL1N28);

    VL1N494 <= VL1N446 and VL1N441 and VL1N418 and VL1N417 and CI ;

    VL1N489 <= qdtmp and qctmp and qbtmp and qatmp and CI;

    RCO <= NOT (VL1N102 AND VL1N28) ;

end archTTL191;

--
--	TTL198
--

use work.ttl_local.all;

entity TTL198 is
    port(SR: IN bit;
         S0: IN bit;
         S1: IN bit;
         A: IN bit;
         B: IN bit;
         C: IN bit;
         D: IN bit;
         E: IN bit;
         F: IN bit;
         G: IN bit;
         H: IN bit;
         CLK: IN bit;
         CLR: IN bit;
	 SL: IN bit;
         QA: OUT bit;
         QB: OUT bit;
         QC: OUT bit;
         QD: OUT bit;
         QE: OUT bit;
         QF: OUT bit;
         QG: OUT bit;
         QH: OUT bit);
end TTL198;

architecture archTTL198 of TTL198 is
    signal VL1N27: bit;

begin
    VL1I1: UNSR8
        port map(SL => SL,
                 SR => SR,
                 S0 => S0,
                 S1 => S1,
                 D7 => A,
                 D6 => B,
                 D5 => C,
                 D4 => D,
                 D3 => E,
                 D2 => F,
                 D1 => G,
                 D0 => H,
                 CLK => CLK,
                 R => VL1N27,
                 Q7 => QA,
                 Q6 => QB,
                 Q5 => QC,
                 Q4 => QD,
                 Q3 => QE,
                 Q2 => QF,
                 Q1 => QG,
                 Q0 => QH);

    VL1N27 <= NOT CLR ;

end archTTL198;

--
--	TTL199
--

use work.ttl_local.all;

entity TTL199 is
    port(J: IN bit;
         K: IN bit;
         SNL: IN bit;
         A: IN bit;
         B: IN bit;
         C: IN bit;
         D: IN bit;
         E: IN bit;
         F: IN bit;
         G: IN bit;
         H: IN bit;
         CI: IN bit;
         CLK: IN bit;
         CLR: IN bit;
         QA: OUT bit;
         QB: OUT bit;
         QC: OUT bit;
         QD: OUT bit;
         QE: OUT bit;
         QF: OUT bit;
         QG: OUT bit;
         QH: OUT bit);
end TTL199;

architecture archTTL199 of TTL199 is

    signal VL1N38: bit;
    signal VL1N44: bit;
    signal VL1N57: bit;
    signal VL1N79: bit;
    signal qatmp : bit;

begin

    QA <= qatmp;

    VL1I1: SHIFT8
        port map(SI => VL1N79,
                 L => VL1N57,
                 D7 => H,
                 D6 => G,
                 D5 => F,
                 D4 => E,
                 D3 => D,
                 D2 => C,
                 D1 => B,
                 D0 => A,
                 EN => one,
                 CLK => VL1N44,
                 R => VL1N38,
                 Q7 => QH,
                 Q6 => QG,
                 Q5 => QF,
                 Q4 => QE,
                 Q3 => QD,
                 Q2 => QC,
                 Q1 => QB,
                 Q0 => qatmp);

    VL1N44 <=  (CI OR CLK) ;

    VL1N38 <= NOT CLR ;

    VL1N57 <= NOT SNL ;

    VL1I91: MUX1OF2
        port map(EN => one,
                 S => qatmp,
                 D0 => J,
                 D1 => K,
                 Y => VL1N79);

end archTTL199;

--
--	TTL20
--

use work.ttl_local.all;

entity TTL20 is
    port(QN: OUT bit;
	 A: IN bit;
         B: IN bit;
         C: IN bit;
         D: IN bit);
end TTL20;

architecture archTTL20 of TTL20 is

begin
    QN <= NOT (A and B and C and D) ;
end archTTL20;

--
--	TTL21
--

use work.ttl_local.all;

entity TTL21 is
    port(Q: OUT bit;
	 A: IN bit;
         B: IN bit;
         C: IN bit;
         D: IN bit);
end TTL21;

architecture archTTL21 of TTL21 is

begin
    Q <= a and b and c and d ;
end archTTL21;

--
--	TTL240
--

use work.ttl_local.all;

entity TTL240 is
    port(G: IN bit;
         A1: IN bit;
         A2: IN bit;
         A3: IN bit;
         A4: IN bit;
         Y1: OUT x01z;
         Y2: OUT x01z;
         Y3: OUT x01z;
         Y4: OUT x01z);
end TTL240;

architecture archTTL240 of TTL240 is
    signal VL1N45: bit;
    signal VL1N56: bit;
    signal VL1N58: bit;
    signal VL1N60: bit;
    signal VL1N62: bit;

begin
    VL1N62 <= NOT A1 ;

    VL1N60 <= NOT A2 ;

    VL1N58 <= NOT A3 ;

    VL1N56 <= NOT A4 ;

    VL1I2: TRIOUT
        port map(X => VL1N62,
                 OE => VL1N45,
                 Y => Y1);

    VL1I5: TRIOUT
        port map(X => VL1N60,
                 OE => VL1N45,
                 Y => Y2);

    VL1N45 <= NOT G ;

    VL1I6: TRIOUT
        port map(X => VL1N58,
                 OE => VL1N45,
                 Y => Y3);

    VL1I7: TRIOUT
        port map(X => VL1N56,
                 OE => VL1N45,
                 Y => Y4);

end archTTL240;

--
--	TTL244
--

use work.ttl_local.all;

entity TTL244 is
    port(G: IN bit;
         A1: IN bit;
         A2: IN bit;
         A3: IN bit;
         A4: IN bit;
         Y1: OUT x01z;
         Y2: OUT x01z;
         Y3: OUT x01z;
         Y4: OUT x01z);
end TTL244;

architecture archTTL244 of TTL244 is
    signal VL1N45: bit;

begin
    VL1I2: TRIOUT
        port map(X => A1,
                 OE => VL1N45,
                 Y => Y1);

    VL1I5: TRIOUT
        port map(X => A2,
                 OE => VL1N45,
                 Y => Y2);

    VL1N45 <= NOT G ;

    VL1I6: TRIOUT
        port map(X => A3,
                 OE => VL1N45,
                 Y => Y3);

    VL1I7: TRIOUT
        port map(X => A4,
                 OE => VL1N45,
                 Y => Y4);

end archTTL244;

--
--	TTL25
--

use work.ttl_local.all;

entity TTL25 is
    port(QN: OUT bit;
	 A: IN bit;
         B: IN bit;
         C: IN bit;
         D: IN bit;
         G: IN bit);
end TTL25;

architecture archTTL25 of TTL25 is
    signal VL1N12: bit;
    signal VL1N14: bit;
    signal VL1N16: bit;
    signal VL1N9: bit;

begin
    QN <= NOT (VL1N9 or VL1N12 or VL1N14 or VL1N16) ;
    VL1N12 <=  (B AND G) ;

    VL1N14 <=  (C AND G) ;

    VL1N9 <=  (A AND G) ;

    VL1N16 <=  (D AND G) ;

end archTTL25;

--
--	TTL251
--

use work.ttl_local.all;

entity TTL251 is
    port(D0: IN bit;
         D1: IN bit;
         D2: IN bit;
         D3: IN bit;
         D4: IN bit;
         D5: IN bit;
         D6: IN bit;
         D7: IN bit;
         G: IN bit;
	 A: IN bit;
         B: IN bit;
         C: IN bit;
         Y: OUT x01z;
         W: OUT x01z);
end TTL251;

architecture archTTL251 of TTL251 is

    signal VL1N31: bit;
    signal VL1N45: bit;
    signal VL1N47: bit;

begin
    VL1I1: MUX1OF8
        port map(EN => one,
                 S0 => A,
                 S1 => B,
                 S2 => C,
                 D0 => D0,
                 D1 => D1,
                 D2 => D2,
                 D3 => D3,
                 D4 => D4,
                 D5 => D5,
                 D6 => D6,
                 D7 => D7,
                 Y => VL1N45);

    VL1N31 <= NOT G ;

    VL1N47 <= NOT VL1N45 ;

    VL1I53: TRIOUT
        port map(X => VL1N45,
                 OE => VL1N31,
                 Y => Y);

    VL1I54: TRIOUT
        port map(X => VL1N47,
                 OE => VL1N31,
                 Y => W);

end archTTL251;

--
--	TTL253
--

use work.ttl_local.all;

entity TTL253 is
    port(A: IN bit;
         B: IN bit;
         G: IN bit;
         C0: IN bit;
	 C1: IN bit;
         C2: IN bit;
         C3: IN bit;
         Y: OUT x01z);
end TTL253;

architecture archTTL253 of TTL253 is

    signal VL1N15: bit;
    signal VL1N33: bit;

begin
    VL1I1: MUX1OF4
        port map(EN => one,
                 S0 => A,
                 S1 => B,
                 D0 => C0,
                 D1 => C1,
                 D2 => C2,
                 D3 => C3,
                 Y => VL1N33);

    VL1N15 <= NOT G ;

    VL1I30: TRIOUT
        port map(X => VL1N33,
                 OE => VL1N15,
                 Y => Y);

end archTTL253;

--
--	TTL257
--

use work.ttl_local.all;

entity TTL257 is
    port(A: IN bit;
         B: IN bit;
         G: IN bit;
         S: IN bit;
         Y: OUT x01z);
end TTL257;

architecture archTTL257 of TTL257 is

    signal VL1N35: bit;
    signal VL1N37: bit;

begin
    VL1I1: MUX1OF2
        port map(EN => one,
                 S => S,
                 D0 => A,
                 D1 => B,
                 Y => VL1N35);

    VL1I27: TRIOUT
        port map(X => VL1N35,
                 OE => VL1N37,
                 Y => Y);

    VL1N37 <= NOT G ;

end archTTL257;

--
--	TTL27
--

use work.ttl_local.all;

entity TTL27 is
    port(QN: OUT bit;
	 A: IN bit;
         B: IN bit;
         C: IN bit);
end TTL27;

architecture archTTL27 of TTL27 is

begin
    QN <= NOT (A OR B OR C) ;
end archTTL27;

--
--	TTL273
--

use work.ttl_local.all;

entity TTL273 is
    port(D1: IN bit;
         D2: IN bit;
         D4: IN bit;
         D3: IN bit;
         D5: IN bit;
         D6: IN bit;
	 D7: IN bit;
         D8: IN bit;
         CLK: IN bit;
         CLR: IN bit;
         Q1: OUT bit;
         Q2: OUT bit;
         Q3: OUT bit;
         Q4: OUT bit;
         Q5: OUT bit;
         Q6: OUT bit;
         Q7: OUT bit;
         Q8: OUT bit);
end TTL273;

architecture archTTL273 of TTL273 is

    signal R: bit;

begin
    R <= NOT CLR ;

    VL1I108: REG4
        port map(D3 => D4,
                 D2 => D3,
                 D1 => D2,
                 D0 => D1,
                 EN => one,
                 CLK => CLK,
                 R => R,
                 Q3 => Q4,
                 Q2 => Q3,
                 Q1 => Q2,
                 Q0 => Q1);

    VL1I111: REG4
        port map(D3 => D8,
                 D2 => D7,
                 D1 => D6,
                 D0 => D5,
                 EN => one,
                 CLK => CLK,
                 R => R,
                 Q3 => Q8,
                 Q2 => Q7,
                 Q1 => Q6,
                 Q0 => Q5);

end archTTL273;

--
--	TTL299
--

use work.ttl_local.all;

entity TTL299 is
    port(SR: IN bit;
         S0: IN bit;
         S1: IN bit;
         G1: IN bit;
         G2: IN bit;
         CLK: IN bit;
         CLR: IN bit;
         SL: IN bit;
         QA: OUT bit;
         A: INOUT x01z;
         B: INOUT x01z;
         C: INOUT x01z;
         D: INOUT x01z;
         E: INOUT x01z;
         F: INOUT x01z;
         G: INOUT x01z;
         H: INOUT x01z;
	 QH: OUT bit);
end TTL299;

architecture archTTL299 of TTL299 is
    signal VL1N12: bit;
    signal VL1N14: bit;
    signal VL1N18: bit;
    signal VL1N38: bit;
    signal VL1N85: bit;
    signal D0: bit;
    signal D1: bit;
    signal D2: bit;
    signal D3: bit;
    signal D4: bit;
    signal D5: bit;
    signal D6: bit;
    signal D7: bit;
    signal Q1: bit;
    signal Q2: bit;
    signal Q3: bit;
    signal Q4: bit;
    signal Q5: bit;
    signal Q6: bit;
    signal qatmp,qhtmp : bit;

begin

    QA <= qatmp;
    QH <= qhtmp;

    VL1I1: UNSR8
        port map(SL => SL,
                 SR => SR,
                 S0 => S0,
                 S1 => S1,
                 D7 => D7,
                 D6 => D6,
                 D5 => D5,
                 D4 => D4,
                 D3 => D3,
                 D2 => D2,
                 D1 => D1,
                 D0 => D0,
                 CLK => CLK,
                 R => VL1N38,
                 Q7 => qatmp,
                 Q6 => Q6,
                 Q5 => Q5,
                 Q4 => Q4,
                 Q3 => Q3,
                 Q2 => Q2,
                 Q1 => Q1,
                 Q0 => qhtmp);

    VL1N14 <= NOT G2 ;

    VL1N18 <= NOT (S0 AND S1) ;

    VL1N38 <= NOT CLR ;

    VL1N85 <= VL1N18 and VL1N12 and VL1N14 ;

    VL1N12 <= NOT G1 ;

    VL1I50: BUFOE
        port map(X => Q1,
                 OE => VL1N85,
                 Y => G,
                 YFB => D1);

    VL1I51: BUFOE
        port map(X => qhtmp,
                 OE => VL1N85,
                 Y => H,
                 YFB => D0);

    VL1I52: BUFOE
        port map(X => Q3,
                 OE => VL1N85,
                 Y => E,
                 YFB => D3);

    VL1I57: BUFOE
        port map(X => Q6,
                 OE => VL1N85,
                 Y => B,
                 YFB => D6);

    VL1I58: BUFOE
        port map(X => Q5,
                 OE => VL1N85,
                 Y => C,
                 YFB => D5);

    VL1I59: BUFOE
        port map(X => Q4,
                 OE => VL1N85,
                 Y => D,
                 YFB => D4);

    VL1I60: BUFOE
        port map(X => qatmp,
                 OE => VL1N85,
                 Y => A,
                 YFB => D7);

    VL1I7: BUFOE
        port map(X => Q2,
                 OE => VL1N85,
                 Y => F,
                 YFB => D2);

end archTTL299;

--
--	TTL30
--

use work.ttl_local.all;

entity TTL30 is
    port(QN: OUT bit;
	 A: IN bit;
         B: IN bit;
         C: IN bit;
         D: IN bit;
         E: IN bit;
         F: IN bit;
         G: IN bit;
         H: IN bit);
end TTL30;

architecture archTTL30 of TTL30 is

begin
    QN <= NOT (a and b and c and d and e and f and g and h) ;
end archTTL30;

--
--	TTL32
--

use work.ttl_local.all;

entity TTL32 is
    port(Q: OUT bit;
	 A: IN bit;
         B: IN bit);
end TTL32;

architecture archTTL32 of TTL32 is

begin
    Q <=  (A OR B) ;

end archTTL32;

--
--	TTL322
--

use work.ttl_local.all;

entity TTL322 is
    port(G1: IN bit;
         SNP: IN bit;
         SE: IN bit;
         D1: IN bit;
         DS: IN bit;
         D0: IN bit;
         CLK: IN bit;
         CLR: IN bit;
	 OE: IN bit;
         A: INOUT x01z;
         B: INOUT x01z;
         C: INOUT x01z;
         D: INOUT x01z;
         E: INOUT x01z;
         F: INOUT x01z;
         G: INOUT x01z;
         H: INOUT x01z;
         QH: OUT bit);
end TTL322;

architecture archTTL322 of TTL322 is

    signal VL1N110: bit;
    signal VL1N182: bit;
    signal VL1N186: bit;
    signal VL1N216: bit;
    signal VL1N87: bit;
    signal VL1N92: bit;
    signal DI0: bit;
    signal DI1: bit;
    signal DI2: bit;
    signal DI3: bit;
    signal DI4: bit;
    signal DI5: bit;
    signal DI6: bit;
    signal DI7: bit;
    signal Q0: bit;
    signal Q1: bit;
    signal Q2: bit;
    signal Q3: bit;
    signal Q4: bit;
    signal Q5: bit;
    signal Q6: bit;
    signal qhtmp : bit;

begin

    QH <= qhtmp;

    VL1I1: BUFOE
        port map(X => Q1,
                 OE => VL1N182,
                 Y => B,
                 YFB => DI1);

    VL1I25: BUFOE
        port map(X => Q3,
                 OE => VL1N182,
                 Y => D,
                 YFB => DI3);

    VL1I26: BUFOE
        port map(X => Q2,
                 OE => VL1N182,
                 Y => C,
                 YFB => DI2);

    VL1I27: BUFOE
        port map(X => Q5,
                 OE => VL1N182,
                 Y => F,
                 YFB => DI5);

    VL1I28: BUFOE
        port map(X => Q4,
                 OE => VL1N182,
                 Y => E,
                 YFB => DI4);

    VL1I29: BUFOE
        port map(X => Q6,
                 OE => VL1N182,
                 Y => G,
                 YFB => DI6);

    VL1I30: BUFOE
        port map(X => qhtmp,
                 OE => VL1N182,
                 Y => H,
                 YFB => DI7);

    VL1I4: BUFOE
        port map(X => Q0,
                 OE => VL1N182,
                 Y => A,
                 YFB => DI0);

    VL1I170: MUX1OF2
        port map(EN => one,
                 S => SE,
                 D0 => Q0,
                 D1 => VL1N186,
                 Y => VL1N110);

    VL1I185: MUX1OF2
        port map(EN => one,
                 S => DS,
                 D0 => D0,
                 D1 => D1,
                 Y => VL1N186);

    VL1I2: SHIFT8
        port map(SI => VL1N110,
                 L => VL1N87,
                 D7 => DI7,
                 D6 => DI6,
                 D5 => DI5,
                 D4 => DI4,
                 D3 => DI3,
                 D2 => DI2,
                 D1 => DI1,
                 D0 => DI0,
                 EN => VL1N216,
                 CLK => CLK,
                 R => VL1N92,
                 Q7 => qhtmp,
                 Q6 => Q6,
                 Q5 => Q5,
                 Q4 => Q4,
                 Q3 => Q3,
                 Q2 => Q2,
                 Q1 => Q1,
                 Q0 => Q0);

    VL1N87 <=  NOT (SNP OR G1) ;

    VL1N216 <= NOT G1 ;

    VL1N92 <= NOT CLR ;

    VL1N182 <=  NOT (OE OR VL1N87) ;

end archTTL322;

--
--	TTL323
--

use work.ttl_local.all;

entity TTL323 is
    port(SR: IN bit;
         S0: IN bit;
         S1: IN bit;
         CLR: IN bit;
         G1: IN bit;
         G2: IN bit;
         CLK: IN bit;
         SL: IN bit;
         QA: OUT bit;
         A: INOUT x01z;
         B: INOUT x01z;
         C: INOUT x01z;
         D: INOUT x01z;
         E: INOUT x01z;
         F: INOUT x01z;
         G: INOUT x01z;
         H: INOUT x01z;
         QH: OUT bit);
end TTL323;

architecture archTTL323 of TTL323 is

    signal VL1N12: bit;
    signal VL1N131: bit;
    signal VL1N132: bit;
    signal VL1N133: bit;
    signal VL1N134: bit;
    signal VL1N135: bit;
    signal VL1N136: bit;
    signal VL1N137: bit;
    signal VL1N14: bit;
    signal VL1N177: bit;
    signal VL1N180: bit;
    signal VL1N182: bit;
    signal VL1N185: bit;
    signal VL1N49: bit;
    signal VL1N85: bit;
    signal D0: bit;
    signal D1: bit;
    signal D2: bit;
    signal D3: bit;
    signal D4: bit;
    signal D5: bit;
    signal D6: bit;
    signal D7: bit;
    signal Q1: bit;
    signal Q2: bit;
    signal Q3: bit;
    signal Q4: bit;
    signal Q5: bit;
    signal Q6: bit;
    signal qatmp,qhtmp : bit;

begin

    QA <= qatmp;
    QH <= qhtmp;

    VL1I1: UNSR8
        port map(SL => SL,
                 SR => SR,
                 S0 => VL1N180,
                 S1 => VL1N182,
                 D7 => D7,
                 D6 => D6,
                 D5 => D5,
                 D4 => D4,
                 D3 => D3,
                 D2 => D2,
                 D1 => D1,
                 D0 => D0,
                 CLK => CLK,
                 R => zero,
                 Q7 => qatmp,
                 Q6 => Q6,
                 Q5 => Q5,
                 Q4 => Q4,
                 Q3 => Q3,
                 Q2 => Q2,
                 Q1 => Q1,
                 Q0 => qhtmp);

    VL1N14 <= NOT G2 ;

    D7 <=  (VL1N137 AND CLR) ;

    D6 <=  (VL1N135 AND CLR) ;

    D5 <=  (VL1N136 AND CLR) ;

    D4 <=  (VL1N133 AND CLR) ;

    D3 <=  (VL1N134 AND CLR) ;

    D2 <=  (VL1N132 AND CLR) ;

    D1 <=  (VL1N131 AND CLR) ;

    D0 <=  (VL1N49 AND CLR) ;

    VL1N180 <=  (S0 OR VL1N177) ;

    VL1N182 <=  (S1 OR VL1N177) ;

    VL1N185 <= NOT (S1 AND S0) ;

    VL1N177 <= NOT CLR ;

    VL1N85 <= VL1N185 and VL1N12 and VL1N14 ;

    VL1N12 <= NOT G1 ;

    VL1I50: BUFOE
        port map(X => Q1,
                 OE => VL1N85,
                 Y => G,
                 YFB => VL1N131);

    VL1I51: BUFOE
        port map(X => qhtmp,
                 OE => VL1N85,
                 Y => H,
                 YFB => VL1N49);

    VL1I52: BUFOE
        port map(X => Q3,
                 OE => VL1N85,
                 Y => E,
                 YFB => VL1N134);

    VL1I57: BUFOE
        port map(X => Q6,
                 OE => VL1N85,
                 Y => B,
                 YFB => VL1N135);

    VL1I58: BUFOE
        port map(X => Q5,
                 OE => VL1N85,
                 Y => C,
                 YFB => VL1N136);

    VL1I59: BUFOE
        port map(X => Q4,
                 OE => VL1N85,
                 Y => D,
                 YFB => VL1N133);

    VL1I60: BUFOE
        port map(X => qatmp,
                 OE => VL1N85,
                 Y => A,
                 YFB => VL1N137);

    VL1I7: BUFOE
        port map(X => Q2,
                 OE => VL1N85,
                 Y => F,
                 YFB => VL1N132);

end archTTL323;

--
--	TTL365
--

use work.ttl_local.all;

entity TTL365 is
    port(G1: IN bit;
         G2: IN bit;
         A1: IN bit;
         A2: IN bit;
	 A3: IN bit;
         A4: IN bit;
         A5: IN bit;
         A6: IN bit;
         Y1: OUT x01z;
         Y2: OUT x01z;
         Y3: OUT x01z;
         Y4: OUT x01z;
         Y5: OUT x01z;
         Y6: OUT x01z);
end TTL365;

architecture archTTL365 of TTL365 is
    signal VL1N45: bit;
    signal VL1N81: bit;
    signal VL1N83: bit;

begin
    VL1I2: TRIOUT
        port map(X => A1,
                 OE => VL1N45,
                 Y => Y1);

    VL1I5: TRIOUT
        port map(X => A2,
                 OE => VL1N45,
                 Y => Y2);

    VL1N83 <= NOT G2 ;

    VL1I6: TRIOUT
        port map(X => A3,
                 OE => VL1N45,
                 Y => Y3);

    VL1I66: TRIOUT
        port map(X => A6,
                 OE => VL1N45,
                 Y => Y6);

    VL1I67: TRIOUT
        port map(X => A5,
                 OE => VL1N45,
                 Y => Y5);

    VL1I7: TRIOUT
        port map(X => A4,
                 OE => VL1N45,
                 Y => Y4);

    VL1N81 <= NOT G1 ;

    VL1N45 <=  (VL1N81 AND VL1N83) ;

end archTTL365;

--
--	TTL366
--

use work.ttl_local.all;

entity TTL366 is
    port(G1: IN bit;
         G2: IN bit;
         A1: IN bit;
         A2: IN bit;
	 A3: IN bit;
         A4: IN bit;
         A5: IN bit;
         A6: IN bit;
         Y1: OUT x01z;
         Y2: OUT x01z;
         Y3: OUT x01z;
         Y4: OUT x01z;
         Y5: OUT x01z;
         Y6: OUT x01z);
end TTL366;

architecture archTTL366 of TTL366 is
    signal VL1N129: bit;
    signal VL1N131: bit;
    signal VL1N133: bit;
    signal VL1N135: bit;
    signal VL1N137: bit;
    signal VL1N139: bit;
    signal VL1N45: bit;
    signal VL1N81: bit;
    signal VL1N83: bit;

begin
    VL1I2: TRIOUT
        port map(X => VL1N139,
                 OE => VL1N45,
                 Y => Y1);

    VL1I5: TRIOUT
        port map(X => VL1N137,
                 OE => VL1N45,
                 Y => Y2);

    VL1N83 <= NOT G2 ;

    VL1I6: TRIOUT
        port map(X => VL1N135,
                 OE => VL1N45,
                 Y => Y3);

    VL1I66: TRIOUT
        port map(X => VL1N129,
                 OE => VL1N45,
                 Y => Y6);

    VL1I67: TRIOUT
        port map(X => VL1N131,
                 OE => VL1N45,
                 Y => Y5);

    VL1I7: TRIOUT
        port map(X => VL1N133,
                 OE => VL1N45,
                 Y => Y4);

    VL1N81 <= NOT G1 ;

    VL1N45 <=  (VL1N81 AND VL1N83) ;

    VL1N137 <= NOT A2 ;

    VL1N139 <= NOT A1 ;

    VL1N135 <= NOT A3 ;

    VL1N133 <= NOT A4 ;

    VL1N131 <= NOT A5 ;

    VL1N129 <= NOT A6 ;

end archTTL366;

--
--	TTL373
--

use work.ttl_local.all;

entity TTL373 is
    port(OC: IN bit;
         D1: IN bit;
         D2: IN bit;
         D3: IN bit;
         D4: IN bit;
         D5: IN bit;
         D6: IN bit;
         D7: IN bit;
         D8: IN bit;
         C: IN bit;
         Q1: OUT x01z;
         Q2: OUT x01z;
         Q3: OUT x01z;
         Q4: OUT x01z;
	 Q5: OUT x01z;
         Q7: OUT x01z;
         Q6: OUT x01z;
         Q8: OUT x01z);
end TTL373;

architecture archTTL373 of TTL373 is
    signal VL1N100: bit;
    signal VL1N102: bit;
    signal VL1N65: bit;
    signal VL1N74: bit;
    signal VL1N76: bit;
    signal VL1N78: bit;
    signal VL1N86: bit;
    signal VL1N90: bit;
    signal VL1N94: bit;

begin
    VL1I1: DLTCH
        port map(D => D1,
                 E => C,
                 Q => VL1N74);

    VL1I10: TRIOUT
        port map(X => VL1N74,
                 OE => VL1N65,
                 Y => Q1);

    VL1I106: DLTCH
        port map(D => D2,
                 E => C,
                 Q => VL1N76);

    VL1I107: DLTCH
        port map(D => D3,
                 E => C,
                 Q => VL1N78);

    VL1I108: DLTCH
        port map(D => D4,
                 E => C,
                 Q => VL1N86);

    VL1N65 <= NOT OC ;

    VL1I110: DLTCH
        port map(D => D5,
                 E => C,
                 Q => VL1N90);

    VL1I111: DLTCH
        port map(D => D6,
                 E => C,
                 Q => VL1N94);

    VL1I112: DLTCH
        port map(D => D8,
                 E => C,
                 Q => VL1N102);

    VL1I113: DLTCH
        port map(D => D7,
                 E => C,
                 Q => VL1N100);

    VL1I16: TRIOUT
        port map(X => VL1N76,
                 OE => VL1N65,
                 Y => Q2);

    VL1I18: TRIOUT
        port map(X => VL1N78,
                 OE => VL1N65,
                 Y => Q3);

    VL1I20: TRIOUT
        port map(X => VL1N86,
                 OE => VL1N65,
                 Y => Q4);

    VL1I22: TRIOUT
        port map(X => VL1N90,
                 OE => VL1N65,
                 Y => Q5);

    VL1I24: TRIOUT
        port map(X => VL1N94,
                 OE => VL1N65,
                 Y => Q6);

    VL1I26: TRIOUT
        port map(X => VL1N100,
                 OE => VL1N65,
                 Y => Q7);

    VL1I28: TRIOUT
        port map(X => VL1N102,
                 OE => VL1N65,
                 Y => Q8);

end archTTL373;

--
--	TTL374
--

use work.ttl_local.all;

entity TTL374 is
    port(OC: IN bit;
         D1: IN bit;
         D2: IN bit;
         D3: IN bit;
         D4: IN bit;
         D5: IN bit;
         D6: IN bit;
         D7: IN bit;
         D8: IN bit;
         CLK: IN bit;
         Q1: OUT x01z;
         Q2: OUT x01z;
         Q3: OUT x01z;
         Q4: OUT x01z;
	 Q5: OUT x01z;
         Q7: OUT x01z;
         Q6: OUT x01z;
         Q8: OUT x01z);
end TTL374;

architecture archTTL374 of TTL374 is
    signal VL1N100: bit;
    signal VL1N102: bit;
    signal VL1N65: bit;
    signal VL1N74: bit;
    signal VL1N76: bit;
    signal VL1N78: bit;
    signal VL1N86: bit;
    signal VL1N90: bit;
    signal VL1N94: bit;

begin
    VL1I1: DFF
        port map(D => D1,
                 CLK => CLK,
                 Q => VL1N74);

    VL1I10: TRIOUT
        port map(X => VL1N74,
                 OE => VL1N65,
                 Y => Q1);

    VL1N65 <= NOT OC ;

    VL1I16: TRIOUT
        port map(X => VL1N76,
                 OE => VL1N65,
                 Y => Q2);

    VL1I18: TRIOUT
        port map(X => VL1N78,
                 OE => VL1N65,
                 Y => Q3);

    VL1I2: DFF
        port map(D => D2,
                 CLK => CLK,
                 Q => VL1N76);

    VL1I20: TRIOUT
        port map(X => VL1N86,
                 OE => VL1N65,
                 Y => Q4);

    VL1I22: TRIOUT
        port map(X => VL1N90,
                 OE => VL1N65,
                 Y => Q5);

    VL1I24: TRIOUT
        port map(X => VL1N94,
                 OE => VL1N65,
                 Y => Q6);

    VL1I26: TRIOUT
        port map(X => VL1N100,
                 OE => VL1N65,
                 Y => Q7);

    VL1I28: TRIOUT
        port map(X => VL1N102,
                 OE => VL1N65,
                 Y => Q8);

    VL1I3: DFF
        port map(D => D3,
                 CLK => CLK,
                 Q => VL1N78);

    VL1I4: DFF
        port map(D => D4,
                 CLK => CLK,
                 Q => VL1N86);

    VL1I5: DFF
        port map(D => D5,
                 CLK => CLK,
                 Q => VL1N90);

    VL1I6: DFF
        port map(D => D6,
                 CLK => CLK,
                 Q => VL1N94);

    VL1I7: DFF
        port map(D => D7,
                 CLK => CLK,
                 Q => VL1N100);

    VL1I8: DFF
        port map(D => D8,
                 CLK => CLK,
                 Q => VL1N102);

end archTTL374;

--
--	TTL73
--

use work.ttl_local.all;

entity TTL73 is
    port(J: IN bit;
         K: IN bit;
         CLK: IN bit;
	 CLR: IN bit;
         Q: OUT bit;
         QN: OUT bit);
end TTL73;

architecture archTTL73 of TTL73 is

    signal VL1N7: bit;
    signal VL1N9: bit;

begin
    VL1N9 <= NOT CLK ;

    VL1I27: JKSRFF
        port map(J => K,
                 K => J,
                 S => VL1N7,
                 R => zero,
                 CLK => VL1N9,
                 Q => QN);

    VL1I5: JKSRFF
        port map(J => J,
                 K => K,
                 S => zero,
                 R => VL1N7,
                 CLK => VL1N9,
                 Q => Q);

    VL1N7 <= NOT CLR ;

end archTTL73;

--
--	TTL74
--

use work.ttl_local.all;

entity TTL74 is
    port(PRE: IN bit;
         D: IN bit;
         CLK: IN bit;
	 CLR: IN bit;
         Q: OUT bit;
         QN: OUT bit);
end TTL74;

architecture archTTL74 of TTL74 is
    signal VL1N50: bit;
    signal VL1N60: bit;
    signal VL1N8: bit;

begin
    VL1N50 <= NOT D ;

    VL1I5: DSRFF
        port map(D => D,
                 S => VL1N8,
                 R => VL1N60,
                 CLK => CLK,
                 Q => Q);

    VL1I6: DSRFF
        port map(D => VL1N50,
                 S => VL1N60,
                 R => VL1N8,
                 CLK => CLK,
                 Q => QN);

    VL1N60 <= NOT CLR ;

    VL1N8 <= NOT PRE ;

end archTTL74;

--
--	TTL75
--

use work.ttl_local.all;

entity TTL75 is
    port(D: IN bit;
         C: IN bit;
         Q: OUT bit;
         QN: OUT bit);
end TTL75;

architecture archTTL75 of TTL75 is
    signal VL1N20: bit;

begin
    VL1I16: DLTCH
        port map(D => D,
                 E => C,
                 Q => Q);

    VL1I18: DLTCH
        port map(D => VL1N20,
                 E => C,
                 Q => QN);

    VL1N20 <= NOT D ;

end archTTL75;

--
--	TTL76
--

use work.ttl_local.all;

entity TTL76 is
    port(PRE: IN bit;
         J: IN bit;
         K: IN bit;
         CLK: IN bit;
         CLR: IN bit;
         Q: OUT bit;
	 QN: OUT bit);
end TTL76;

architecture archTTL76 of TTL76 is
    signal VL1N25: bit;
    signal VL1N7: bit;
    signal VL1N9: bit;

begin
    VL1N9 <= NOT CLK ;

    VL1I27: JKSRFF
        port map(J => K,
                 K => J,
                 S => VL1N7,
                 R => VL1N25,
                 CLK => VL1N9,
                 Q => QN);

    VL1N25 <= NOT PRE ;

    VL1I5: JKSRFF
        port map(J => J,
                 K => K,
                 S => VL1N25,
                 R => VL1N7,
                 CLK => VL1N9,
                 Q => Q);

    VL1N7 <= NOT CLR ;

end archTTL76;

--
--	TTL86
--

use work.ttl_local.all;

entity TTL86 is
    port(Q: OUT bit;
         A: IN bit;
         B: IN bit);
end TTL86;

architecture archTTL86 of TTL86 is

begin
    Q <= A XOR B ;
end archTTL86;
