--
--	Copyright Cypress Semiconductor Corporation, 1994,1995,1996
--	  as an unpublished work.
--

PACKAGE mathpkg IS

    type bvm            is array (integer range <>,integer range <>) of bit;

    COMPONENT add
	PORT (CI, A, B	: IN BIT;
            SUM, CO	: OUT BIT);
    END COMPONENT;

    COMPONENT sub
	PORT (CI, A, B	: IN BIT;
            DIF, CO	: OUT BIT);
    END COMPONENT;

    COMPONENT add4
	PORT (CI		: IN BIT;
	    A3,A2,A1,A0		: IN BIT;
	    B3,B2,B1,B0		: IN BIT;
	    SUM3,SUM2,SUM1,SUM0 : OUT BIT;
            CO			: OUT BIT);
    END COMPONENT;

    COMPONENT fcadd4
	PORT (CI		: IN BIT;
	    A3,A2,A1,A0		: IN BIT;
	    B3,B2,B1,B0		: IN BIT;
	    SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO			: OUT BIT);
    END COMPONENT;

    COMPONENT fbsub4
	PORT (CI		: IN BIT;
	    A3,A2,A1,A0		: IN BIT;
	    B3,B2,B1,B0		: IN BIT;
	    DIF3,DIF2,DIF1,DIF0 : OUT BIT;
            CO			: OUT BIT);
    END COMPONENT;

    COMPONENT add8
	PORT (CI					: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0			: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0			: IN BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0	: OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT fcadd8
	PORT (CI 					: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0			: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0			: IN BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 	: OUT BIT;
	    CO						: OUT BIT);
    END COMPONENT;

    COMPONENT nciadd8
	PORT (
	    A7,A6,A5,A4,A3,A2,A1,A0			: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0			: IN BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 	: OUT BIT;
	    CO						: OUT BIT);
    END COMPONENT;

    COMPONENT fbsub8
	PORT (CI 					: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0			: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0			: IN BIT;
	    DIF7,DIF6,DIF5,DIF4,DIF3,DIF2,DIF1,DIF0 	: OUT BIT;
	    CO						: OUT BIT);
    END COMPONENT;

    COMPONENT add16
	PORT (CI 						: IN BIT;
	    A15,A14,A13,A12,A11,A10,A9,A8			: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0				: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8			: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0				: IN BIT;
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8	: OUT BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 		: OUT BIT;
	    CO							: OUT BIT);
    END COMPONENT;

    COMPONENT fcadd16
	PORT (CI 						: IN BIT;
	    A15,A14,A13,A12,A11,A10,A9,A8			: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0				: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8			: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0				: IN BIT;
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8 	: OUT BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 		: OUT BIT;
	    CO							: OUT BIT);
    END COMPONENT;

    COMPONENT nciadd16
	PORT (
	    A15,A14,A13,A12,A11,A10,A9,A8			: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0				: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8			: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0				: IN BIT;
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8	: OUT BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0		: OUT BIT;
	    CO							: OUT BIT);
    END COMPONENT;

    COMPONENT fbsub16
	PORT (CI 						: IN BIT;
	    A15,A14,A13,A12,A11,A10,A9,A8			: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0				: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8			: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0				: IN BIT;
	    DIF15,DIF14,DIF13,DIF12,DIF11,DIF10,DIF9,DIF8	: OUT BIT;
	    DIF7,DIF6,DIF5,DIF4,DIF3,DIF2,DIF1,DIF0		: OUT BIT;
	    CO							: OUT BIT);
    END COMPONENT;

    COMPONENT mult4x4
        PORT (b3,b2,b1,b0,m3,m2,m1,m0	: IN BIT;
              q0,q1,q2,q3,q4,q5,q6,q7	: OUT BIT);
    END COMPONENT;

    COMPONENT COMPBIT2
	PORT (
	    A0,B0,A1,B1	: IN BIT;
	    EQ0, EQ1	: OUT BIT);
    END COMPONENT;

    COMPONENT EQCOMP4
	PORT (
	    A3,A2,A1,A0,B3,B2,B1,B0	: IN BIT;
	    EQ				: OUT BIT);
    END COMPONENT;

    COMPONENT EQCOMP8
	PORT (
	    A7,A6,A5,A4,A3,A2,A1,A0,B7,B6,B5,B4,B3,B2,B1,B0 : IN BIT;
	    EQ	: OUT	BIT);
    END COMPONENT;

    COMPONENT EQCOMP16
	PORT (
	    A15,A14,A13,A12,A11,A10,A9,A8,A7,A6,A5,A4,A3,A2,A1,A0 : IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0 : IN BIT;
	    EQ	: OUT	BIT);
    END COMPONENT;

END mathpkg;
--
--	ADD
--

USE WORK.cypress.ALL;

ENTITY add IS
	PORT (CI: IN BIT;
	      A, B: IN BIT;
	      SUM: OUT BIT;
	      CO: OUT BIT);
END add;

ARCHITECTURE archadd OF add IS

BEGIN
	SUM <= (A XOR B) XOR CI;
	CO <= (A AND B) OR ((A AND CI) OR (B AND CI));

END archadd;

--
--	SUBtract
--

USE WORK.cypress.ALL;

ENTITY sub IS
	PORT (CI: IN BIT;
	      A, B: IN BIT;
	      DIF: OUT BIT;
	      CO: OUT BIT);
END sub;

ARCHITECTURE archsub OF sub IS

BEGIN
	DIF <= NOT(NOT(A XOR B) XOR CI);
	CO <= (not A AND B) OR ((not A AND CI) OR (B AND CI));

END archsub;

--
--	ADD 2
--

ENTITY add2 IS
    PORT (CI : IN BIT;
	A1,A0: IN BIT;
	B1,B0: IN BIT;
	SUM1,SUM0 : OUT BIT;
	CO: OUT BIT);
END add2;
 
ARCHITECTURE archADD2 of ADD2 IS

BEGIN

    sum0 <= a0 xor b0 xor CI;
    sum1 <= a1 xor b1 xor ((a0 and b0) or (a0 and CI) or (b0 and CI));
    co   <= (a0 AND b0 AND b1) OR
	    (a0 AND b0 AND a1) OR
	    (ci AND b0 AND b1) OR
	    (ci AND b0 AND a1) OR
	    (ci AND a0 AND b1) OR
	    (ci AND a0 AND a1) OR
		   (a1 AND b1);

END archADD2;

--
--      Fast Carry ADD 2
--
 
use work.cypress.all;
  
entity fcadd2 is
    PORT (CI		: IN BIT;
	  A1,A0,B1,B0	: IN  BIT;
	  SUM1,SUM0	: OUT BIT;
	  E,R		: OUT BIT);
end fcadd2;

architecture archfcadd2 of fcadd2 is

begin

    sum0 <= a0 xor b0 xor CI;
    sum1 <= a1 xor b1 xor ((a0 and b0) or (a0 and CI) or (b0 and CI));

    e <= (a1 and b1) or ((a1 or b1) and (a0 and b0));
    r <= (a1 or b1) and (a0 or b0);

end archfcadd2;

--
--	SUB 2
--

ENTITY sub2 IS
    PORT (CI : IN BIT;
	A1,A0: IN BIT;
	B1,B0: IN BIT;
	DIF1,DIF0 : OUT BIT;
	CO: OUT BIT);
END sub2;
 
ARCHITECTURE archSUB2 of SUB2 IS

BEGIN

    dif0 <= NOT(NOT(a0 xor b0) xor CI);
    dif1 <= NOT(NOT(a1 xor b1) xor
	    ((NOT a0 and b0) or (NOT a0 and CI) or (b0 and CI)));
    co   <= (not a0 AND b0 AND b1) OR
	    (not a0 AND b0 AND not a1) OR
	    (ci AND b0 AND b1) OR
	    (ci AND b0 AND not a1) OR
	    (ci AND not a0 AND b1) OR
	    (ci AND not a0 AND not a1) OR
		   (not a1 AND b1);

END archSUB2;

--
--      Fast Borrow SUB 2
--
 
use work.cypress.all;
  
entity fbsub2 is
    PORT (CI		: IN BIT;
	  A1,A0,B1,B0	: IN  BIT;
	  DIF1,DIF0	: OUT BIT;
	  E,R		: OUT BIT);
end fbsub2;

architecture archfbsub2 of fbsub2 is

begin

    dif0 <= not(not(a0 xor b0) xor CI);
    dif1 <= not(not(a1 xor b1) xor ((not a0 and b0) or
	    (not a0 and CI) or (b0 and CI)));

    e <= (not a1 and b1) or ((not a1 or b1) and (not a0 and b0));
    r <= (not a1 or b1) and (not a0 or b0);

end archfbsub2;

--
--	ADD 4
--

ENTITY add4 IS
    PORT (CI : IN BIT;
	A3,A2,A1,A0: IN BIT;
	B3,B2,B1,B0: IN BIT;
	SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	CO: OUT BIT);
END add4;
 
ARCHITECTURE archADD4 of ADD4 IS

			signal c2: bit;
    attribute synthesis_off of c2 : signal is true;

BEGIN

    U1: add2 port map (ci,a1,a0,b1,b0,sum1,sum0,c2);
    U2: add2 port map (c2,a3,a2,b3,b2,sum3,sum2,co);

END archADD4;

--
--	Fast Carry ADD 4
--

ENTITY fcadd4 IS
	PORT (CI : IN BIT;
	    A3,A2,A1,A0: IN BIT;
	    B3,B2,B1,B0: IN BIT;
	    SUM3,SUM2,SUM1,SUM0 : OUT BIT;
            CO: OUT BIT);
END fcadd4;

ARCHITECTURE archfcadd4 OF fcadd4 IS

			signal c2: bit;
    attribute synthesis_off of c2 : signal is true;

BEGIN

    U1: add2 port map (ci,a1,a0,b1,b0,sum1,sum0,c2);
    U2: add2 port map (c2,a3,a2,b3,b2,sum3,sum2,co);

END archfcadd4;

--
--	Fast Borrow SUBtract 4
--

ENTITY fbsub4 IS
	PORT (CI : IN BIT;
	    A3,A2,A1,A0: IN BIT;
	    B3,B2,B1,B0: IN BIT;
	    DIF3,DIF2,DIF1,DIF0 : OUT BIT;
            CO: OUT BIT);
END fbsub4;


ARCHITECTURE archfbsub4 OF fbsub4 IS

			signal c2: bit;
    attribute synthesis_off of c2 : signal is true;

BEGIN

    U1: sub2 port map (ci,a1,a0,b1,b0,dif1,dif0,c2);
    U2: sub2 port map (c2,a3,a2,b3,b2,dif3,dif2,co);

END archfbsub4;

--
--	ADD 8
--

ENTITY add8 IS
    PORT (CI : IN BIT;
	A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	CO: OUT BIT);
END add8;
 
ARCHITECTURE archADD8 of ADD8 IS

			signal c2,c4,c6 : bit;
    attribute synthesis_off of c2,c4,c6 : signal is true;

BEGIN

    U1: add2 port map (ci,a1,a0,b1,b0,sum1,sum0,c2);
    U2: add2 port map (c2,a3,a2,b3,b2,sum3,sum2,c4);
    U3: add2 port map (c4,a5,a4,b5,b4,sum5,sum4,c6);
    U4: add2 port map (c6,a7,a6,b7,b6,sum7,sum6,co);

END archADD8;

--
--	Fast Carry ADD 8
--

use work.cypress.all;
ENTITY fcadd8 is
    PORT (CI : IN BIT;
	A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	CO: OUT BIT);
end fcadd8;

architecture archFCADD8 of FCADD8 is

			    signal c2,c4,c6 : bit;
	attribute synthesis_off of c2,c4,c6 : signal is true;
			    signal e1,e2,e3 : bit;
	attribute synthesis_off of e1,e2,e3 : signal is true;
			    signal r1,r2,r3 : bit;
	attribute synthesis_off of r1,r2,r3 : signal is true;

begin

    U1:   add2 port map (ci,a1,a0,b1,b0,sum1,sum0,c2);
    U2: fcadd2 port map (c2,a3,a2,b3,b2,sum3,sum2,e1,r1);
    U3: fcadd2 port map (c4,a5,a4,b5,b4,sum5,sum4,e2,r2);
    U4: fcadd2 port map (c6,a7,a6,b7,b6,sum7,sum6,e3,r3);

    c4 <= e1 or (c2 and r1);
    c6 <= e2 or ((e1 or (c2 and r1)) and r2);
    co <= e3 or ((e2 or ((e1 or (c2 and r1)) and r2)) and r3);

end archFCADD8;

--
--	No Carry In ADD 8
--

ENTITY nciadd8 is
	PORT (
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
end nciadd8;

architecture archNCIADD8 of NCIADD8 is

begin

    U0: fcadd8 port map(zero,
			a7,a6,a5,a4,a3,a2,a1,a0,b7,b6,b5,b4,b3,b2,b1,b0,
			sum7,sum6,sum5,sum4,sum3,sum2,sum1,sum0,co);

end archNCIADD8;

--
--	Fast Borrow SUBtract 8
--

use work.cypress.all;
ENTITY fbsub8 is
    PORT (CI : IN BIT;
	A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	DIF7,DIF6,DIF5,DIF4,DIF3,DIF2,DIF1,DIF0 : OUT BIT;
	CO: OUT BIT);
end fbsub8;

architecture archFBSUB8 of FBSUB8 is

			    signal c2,c4,c6 : bit;
	attribute synthesis_off of c2,c4,c6 : signal is true;
			    signal e1,e2,e3 : bit;
	attribute synthesis_off of e1,e2,e3 : signal is true;
			    signal r1,r2,r3 : bit;
	attribute synthesis_off of r1,r2,r3 : signal is true;

begin

    U1:   sub2 port map (ci,a1,a0,b1,b0,dif1,dif0,c2);
    U2: fbsub2 port map (c2,a3,a2,b3,b2,dif3,dif2,e1,r1);
    U3: fbsub2 port map (c4,a5,a4,b5,b4,dif5,dif4,e2,r2);
    U4: fbsub2 port map (c6,a7,a6,b7,b6,dif7,dif6,e3,r3);

    c4 <= e1 or (c2 and r1);
    c6 <= e2 or ((e1 or (c2 and r1)) and r2);
    co <= e3 or ((e2 or ((e1 or (c2 and r1)) and r2)) and r3);

end archFBSUB8;


--
--	ADD 16
--

ENTITY add16 IS
    PORT (CI : IN BIT;
	A15,A14,A13,A12,A11,A10,A9,A8,A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8 : OUT BIT;
	SUM7, SUM6, SUM5, SUM4, SUM3, SUM2, SUM1,SUM0 : OUT BIT;
	CO: OUT BIT);
END add16;
 
ARCHITECTURE archADD16 of ADD16 IS

			signal c2,c4,c6,c8,c10,c12,c14 : bit;
    attribute synthesis_off of c2,c4,c6,c8,c10,c12,c14 : signal is true;

BEGIN

    U1: add2 port map (ci, a1, a0, b1, b0, sum1, sum0, c2);
    U2: add2 port map (c2, a3, a2, b3, b2, sum3, sum2, c4);
    U3: add2 port map (c4, a5, a4, b5, b4, sum5, sum4, c6);
    U4: add2 port map (c6, a7, a6, b7, b6, sum7, sum6, c8);
    U5: add2 port map (c8, a9, a8, b9, b8, sum9, sum8, c10);
    U6: add2 port map (c10,a11,a10,b11,b10,sum11,sum10,c12);
    U7: add2 port map (c12,a13,a12,b13,b12,sum13,sum12,c14);
    U8: add2 port map (c14,a15,a14,b15,b14,sum15,sum14,co);

END archADD16;

--
--	Fast Carry ADD 16
--

ENTITY fcadd16 is
	PORT (CI : IN BIT;
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8 : OUT BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
end fcadd16;

architecture archFCADD16 of FCADD16 is

			    signal c2,c4,c6,c8,ca,cc,ce : bit;
	attribute synthesis_off of c2,c4,c6,c8,ca,cc,ce : signal is true;
			    signal e1,e2,e3,e4,e5,e6,e7 : bit;
	attribute synthesis_off of e1,e2,e3,e4,e5,e6,e7 : signal is true;
			    signal r1,r2,r3,r4,r5,r6,r7 : bit;
	attribute synthesis_off of r1,r2,r3,r4,r5,r6,r7 : signal is true;

begin

    U1:   add2 port map (ci,a1, a0, b1, b0, sum1, sum0, c2);
    U2: fcadd2 port map (c2,a3, a2, b3, b2, sum3, sum2, e1,r1);
    U3: fcadd2 port map (c4,a5, a4, b5, b4, sum5, sum4, e2,r2);
    U4: fcadd2 port map (c6,a7, a6, b7, b6, sum7, sum6, e3,r3);
    U5: fcadd2 port map (c8,a9, a8, b9, b8, sum9, sum8, e4,r4);
    U6: fcadd2 port map (ca,a11,a10,b11,b10,sum11,sum10,e5,r5);
    U7: fcadd2 port map (cc,a13,a12,b13,b12,sum13,sum12,e6,r6);
    U8: fcadd2 port map (ce,a15,a14,b15,b14,sum15,sum14,e7,r7);

    c4 <= e1 or (c2 and r1);
    c6 <= e2 or ((e1 or (c2 and r1)) and r2);
    c8 <= e3 or ((e2 or ((e1 or (c2 and r1)) and r2)) and r3);
    ca <= e4 or ((e3 or ((e2 or ((e1 or (c2 and r1)) and r2)) and r3)) and r4);
    cc <= e5 or ((e4 or ((e3 or ((e2 or ((e1 or (c2 and r1)) and r2)) and r3)) and r4)) and r5);
    ce <= e6 or ((e5 or ((e4 or ((e3 or ((e2 or ((e1 or (c2 and r1)) and r2)) and r3)) and r4)) and r5)) and r6);
    co <= e7 or ((e6 or ((e5 or ((e4 or ((e3 or ((e2 or ((e1 or (c2 and r1)) and r2)) and r3)) and r4)) and r5)) and r6)) and r7);

end archFCADD16;

--
--	No Carry In ADD 16
--

ENTITY nciadd16 is
	PORT (
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8 : OUT BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
end nciadd16;

architecture archNCIADD16 of NCIADD16 is

begin

    U0: fcadd16 port map(zero,
			a15,a14,a13,a12,a11,a10,a9,a8,a7,a6,a5,a4,a3,a2,a1,a0,
			b15,b14,b13,b12,b11,b10,b9,b8,b7,b6,b5,b4,b3,b2,b1,b0,
			sum15,sum14,sum13,sum12,sum11,sum10,sum9,sum8,
			sum7, sum6, sum5, sum4, sum3, sum2, sum1,sum0,co);

end archNCIADD16;

--
--	Fast Borrow SUBtract 16
--

ENTITY fbsub16 is
	PORT (CI : IN BIT;
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    DIF15,DIF14,DIF13,DIF12,DIF11,DIF10,DIF9,DIF8 : OUT BIT;
	    DIF7,DIF6,DIF5,DIF4,DIF3,DIF2,DIF1,DIF0 : OUT BIT;
	    CO: OUT BIT);
end fbsub16;

architecture archfbsub16 of fbsub16 is

			    signal c2,c4,c6,c8,ca,cc,ce : bit;
	attribute synthesis_off of c2,c4,c6,c8,ca,cc,ce : signal is true;
			    signal e1,e2,e3,e4,e5,e6,e7 : bit;
	attribute synthesis_off of e1,e2,e3,e4,e5,e6,e7 : signal is true;
			    signal r1,r2,r3,r4,r5,r6,r7 : bit;
	attribute synthesis_off of r1,r2,r3,r4,r5,r6,r7 : signal is true;

begin

    U1:   sub2 port map (ci,a1, a0, b1, b0, dif1, dif0, c2);
    U2: fbsub2 port map (c2,a3, a2, b3, b2, dif3, dif2, e1,r1);
    U3: fbsub2 port map (c4,a5, a4, b5, b4, dif5, dif4, e2,r2);
    U4: fbsub2 port map (c6,a7, a6, b7, b6, dif7, dif6, e3,r3);
    U5: fbsub2 port map (c8,a9, a8, b9, b8, dif9, dif8, e4,r4);
    U6: fbsub2 port map (ca,a11,a10,b11,b10,dif11,dif10,e5,r5);
    U7: fbsub2 port map (cc,a13,a12,b13,b12,dif13,dif12,e6,r6);
    U8: fbsub2 port map (ce,a15,a14,b15,b14,dif15,dif14,e7,r7);

    c4 <= e1 or (c2 and r1);
    c6 <= e2 or ((e1 or (c2 and r1)) and r2);
    c8 <= e3 or ((e2 or ((e1 or (c2 and r1)) and r2)) and r3);
    ca <= e4 or ((e3 or ((e2 or ((e1 or (c2 and r1)) and r2)) and r3)) and r4);
    cc <= e5 or ((e4 or ((e3 or ((e2 or ((e1 or (c2 and r1)) and r2)) and r3)) and r4)) and r5);
    ce <= e6 or ((e5 or ((e4 or ((e3 or ((e2 or ((e1 or (c2 and r1)) and r2)) and r3)) and r4)) and r5)) and r6);
    co <= e7 or ((e6 or ((e5 or ((e4 or ((e3 or ((e2 or ((e1 or (c2 and r1)) and r2)) and r3)) and r4)) and r5)) and r6)) and r7);

end archfbsub16;
 
--
--      MULTiply 4 by 4
--

use work.rtlpkg.all;
use work.mathpkg.all;

ENTITY mult4x4 IS
        PORT (b3,b2,b1,b0,m3,m2,m1,m0 : IN BIT;
              q0,q1,q2,q3,q4,q5,q6,q7 : OUT BIT);
END mult4x4;

ARCHITECTURE archMULT4x4 of mult4x4 IS

    signal dataA, dataB	: bit_vector (3 downto 0);
    signal I,c,s,ci,si	: bvm((dataA'length) downto 0,(dataA'length) downto 0);
    signal p		: bit_vector (7 downto 0);

begin

    dataA(0) <= b0;
    dataA(1) <= b1;
    dataA(2) <= b2;
    dataA(3) <= b3;
    dataB(0) <= m0;
    dataB(1) <= m1;
    dataB(2) <= m2;
    dataB(3) <= m3;

    I0: for j in dataA'low to dataA'high generate
	I1: for k in dataB'low to dataB'high generate
	    I(j,k) <= dataA(j) AND dataB(k);
	end generate;
    end generate;

    CL: for l in 0 to (dataA'high - 1) generate
	CM: for m in 0 to (dataA'high) generate
	-- Column 0 of the array.
	    C0: if (m = dataA'low) generate
		si(l,m) <= I(m,l+1) xor I(m+1,l);
		ci(l,m) <= I(m,l+1) and I(m+1,l);
	    end generate;
	-- Column 1 through m-1 of the array.
	    C1: if ((m > dataA'low) and (m < dataA'high)) generate
		C2: if (l < (dataA'high - 1)) generate
		si(l,m) <= (si(l+1,m-1) xor ci(l,m-1) xor I(m+1,l));
		ci(l,m) <= (si(l+1,m-1) and ci(l,m-1)) or
			   (si(l+1,m-1) and I(m+1,l)) or
			   (ci(l,m-1) and I(m+1,l));
		end generate;
		C3: if (l = (dataA'high - 1)) generate
		si(l,m) <= (I(m,l+1) xor ci(l,m-1) xor I(m+1,l));
		ci(l,m) <= (I(m,l+1) and ci(l,m-1)) or
			   (I(m,l+1) and I(m+1,l)) or
			   (ci(l,m-1) and I(m+1,l));
		end generate;
	    end generate;
	-- Column m of the array.
	    C4: if (m = dataA'high) generate
		C5: if (l = dataA'low) generate
		si(l,m) <= (s(l+1,m-1) xor c(l,m-1));
		ci(l,m) <= (s(l+1,m-1) and c(l,m-1));
		end generate;
		C6: if ((l > dataA'low) and (l < (dataA'high - 1))) generate
		si(l,m) <= s(l+1,m-1) xor c(l,m-1) xor ci(l-1,m);
		ci(l,m) <= (s(l+1,m-1) and c(l,m-1)) or
			   (s(l+1,m-1) and ci(l-1,m)) or
			   (c(l,m-1) and ci(l-1,m));
		end generate;
		C7: if (l = (dataA'high - 1)) generate
		si(l,m) <= (I(m,l+1) xor c(l,m-1) xor c(l-1,m));
		ci(l,m) <= (I(m,l+1) and c(l,m-1)) or
			   (I(m,l+1) and c(l-1,m)) or
			   (c(l,m-1) and c(l-1,m));
		end generate;
	    end generate;
	    BS: buf port map (si(l,m), s(l,m));
	    BC: buf port map (ci(l,m), c(l,m));
	end generate;
    end generate;

    p(p'low) <= dataA(0) and dataB(0);
    P0: for l in 1 to dataA'high generate
	p(l) <= s(0,l-1);
    end generate;
    P1: for l in dataA'length to (p'high - 1) generate
	p(l) <= s(l-dataA'length,dataA'high);
    end generate;
    p(p'high) <= c(dataA'high-1,dataA'high);

    q0 <= p(0);
    q1 <= p(1);
    q2 <= p(2);
    q3 <= p(3);
    q4 <= p(4);
    q5 <= p(5);
    q6 <= p(6);
    q7 <= p(7);

END archMULT4x4;

--
--	COMPare 2 BITs
--

use work.cypress.all;
use work.rtlpkg.all;

entity COMPBIT2 is
    PORT (
	A0,B0,A1,B1 : IN BIT;
	EQ0, EQ1 : OUT BIT);
end COMPBIT2;

architecture archCOMPBIT2 of COMPBIT2 is
begin

	eq0 <= (NOT(a1 xor b1) AND a0 AND NOT b0) OR (NOT a0 AND b0);
	eq1 <= (NOT(a1 xor b1));

end archCOMPBIT2;

--
--	EQual COMPare 4
--

use work.cypress.all;
use work.rtlpkg.all;
entity EQCOMP4 is
	PORT (
	    A3,A2,A1,A0,B3,B2,B1,B0 : IN BIT;
	    EQ	: OUT	BIT);
end EQCOMP4;

architecture archEQCOMP4 of EQCOMP4 is

			    signal e3,e2,e1,e0 : bit;

begin
	e3 <= a3 xor b3;
	e2 <= a2 xor b2;
	e1 <= a1 xor b1;
	e0 <= a0 xor b0;

	eq <= (not e3 and not e2 and not e1 and not e0);

end archEQCOMP4;

--
--	EQual COMPare 8
--

use work.cypress.all;
use work.rtlpkg.all;
entity EQCOMP8 is
	PORT (
	    A7,A6,A5,A4,A3,A2,A1,A0,B7,B6,B5,B4,B3,B2,B1,B0 : IN BIT;
	    EQ	: OUT	BIT);
end EQCOMP8;

architecture archEQCOMP8 of EQCOMP8 is

			    signal e7,e6,e5,e4,e3,e2,e1,e0: bit;

begin
	e7 <= a7 xor b7;
	e6 <= a6 xor b6;
	e5 <= a5 xor b5;
	e4 <= a4 xor b4;
	e3 <= a3 xor b3;
	e2 <= a2 xor b2;
	e1 <= a1 xor b1;
	e0 <= a0 xor b0;

	eq <= not e7 and not e6 and not e5 and not e4
	  and not e3 and not e2 and not e1 and not e0;

end archEQCOMP8;

--
--	EQual COMPare 16
--

use work.cypress.all;
use work.rtlpkg.all;
entity EQCOMP16 is
	PORT (
	    A15,A14,A13,A12,A11,A10,A9,A8,A7,A6,A5,A4,A3,A2,A1,A0 : IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0 : IN BIT;
	    EQ	: OUT	BIT);
end EQCOMP16;

architecture archEQCOMP16 of EQCOMP16 is

			    signal e1,e0 : bit;
	attribute synthesis_off of e1,e0 : signal is true;

begin
	C1: eqcomp8 port map (a15,a14,a13,a12,a11,a10,a9,a8,
				b15,b14,b13,b12,b11,b10,b9,b8,e1);
	C0: eqcomp8 port map (a7,a6,a5,a4,a3,a2,a1,a0,
				b7,b6,b5,b4,b3,b2,b1,b0,e0);
	eq <= e1 and e0;

end archEQCOMP16;
