--
--	Copyright Cypress Semiconductor Corporation, 1994,1995,1996
--	  as an unpublished work.
--

library mgc_portable;
use mgc_portable.qsim_logic.all;

PACKAGE c20g10cp IS

    TYPE reg_def  IS (reg, comb, dblreg);		-- Noreg generic.
    TYPE polarity IS (invt, ninv);	-- Port polarity.
    TYPE fb_type  IS (xpin, xreg, adj);	-- feedback select.

    COMPONENT c20g10cm
	GENERIC (
	    registered	: reg_def	:= reg;
	    inv_setting	: polarity	:= ninv;
	    bta_sel	: fb_type	:= xreg;
	    Tpd		: TIME		:= 7500 ps;  -- PLD20G10C-7
	    Tpzx	: TIME		:= 7500 ps;
	    Tpxz	: TIME		:= 7500 ps;
	    Tco		: TIME		:= 6500 ps;
	    Ts		: TIME		:= 3 ns;
	    Th		: TIME		:= 0 ns;
	    Twh		: TIME		:= 3 ns;
	    Twl		: TIME		:= 3 ns);

	PORT (
		d	: IN	qsim_state;
		clk	: IN	qsim_state;
		oe	: IN	qsim_state;
		y	: INOUT qsim_state;
		fb	: OUT	qsim_state);
    END COMPONENT;

END c20g10cp;

